=== modified file 'INSTALL'
--- INSTALL	2008-10-28 18:00:20 +0000
+++ INSTALL	2009-02-15 09:28:06 +0000
@@ -39,17 +39,18 @@
 *** Mandos Server
     + GnuTLS 2.4          http://www.gnu.org/software/gnutls/
     + Avahi 0.6.16        http://www.avahi.org/
-    + Python 2.4          http://www.python.org/
+    + Python 2.5          http://www.python.org/
     + Python-GnuTLS 1.1.5 http://pypi.python.org/pypi/python-gnutls/
     + dbus-python 0.82.4  http://dbus.freedesktop.org/doc/dbus-python/
     + python-ctypes 1.0.0 http://pypi.python.org/pypi/ctypes
+    + PyGObject 2.14.2    http://library.gnome.org/devel/pygobject/
     
     Strongly recommended:
     + fping 2.4b2-to-ipv6 http://www.fping.com/
     
     Package names:
     python-gnutls avahi-daemon python python-avahi python-dbus
-    python-ctypes
+    python-ctypes python-gobject
    
 *** Mandos Client
     + initramfs-tools 0.85i

=== modified file 'Makefile'
--- Makefile	2009-01-10 00:53:09 +0000
+++ Makefile	2009-02-25 01:31:13 +0000
@@ -1,6 +1,6 @@
 WARN=-O -Wall -Wformat=2 -Winit-self -Wmissing-include-dirs \
 	-Wswitch-default -Wswitch-enum -Wunused-parameter \
-	-Wstrict-aliasing=2 -Wextra -Wfloat-equal -Wundef -Wshadow \
+	-Wstrict-aliasing=1 -Wextra -Wfloat-equal -Wundef -Wshadow \
 	-Wunsafe-loop-optimizations -Wpointer-arith \
 	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
 	-Wconversion -Wstrict-prototypes -Wold-style-definition \
@@ -16,7 +16,7 @@
 OPTIMIZE=-Os
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.0.3
+version=1.0.8
 SED=sed
 
 ## Use these settings for a traditional /usr/local install
@@ -39,8 +39,9 @@
 GNUTLS_LIBS=$(shell libgnutls-config --libs)
 AVAHI_CFLAGS=$(shell pkg-config --cflags-only-I avahi-core)
 AVAHI_LIBS=$(shell pkg-config --libs avahi-core)
-GPGME_CFLAGS=$(shell gpgme-config --cflags)
-GPGME_LIBS=$(shell gpgme-config --libs)
+GPGME_CFLAGS=$(shell gpgme-config --cflags; getconf LFS_CFLAGS)
+GPGME_LIBS=$(shell gpgme-config --libs; getconf LFS_LIBS; \
+	getconf LFS_LDFLAGS)
 
 # Do not change these two
 CFLAGS=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
@@ -77,7 +78,7 @@
 PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
 	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo
 CPROGS=plugin-runner $(PLUGINS)
-PROGS=mandos mandos-keygen mandos-list $(CPROGS)
+PROGS=mandos mandos-keygen mandos-ctl $(CPROGS)
 DOCS=mandos.8 plugin-runner.8mandos mandos-keygen.8 \
 	plugins.d/mandos-client.8mandos \
 	plugins.d/password-prompt.8mandos mandos.conf.5 \
@@ -151,7 +152,7 @@
 # Update all these files with version number $(version)
 common.ent: Makefile
 	$(SED) --in-place \
-		--expression='s/^\(<ENTITY VERSION "\)[^"]*">$$/\1$(version)"/' \
+		--expression='s/^\(<!ENTITY version "\)[^"]*">$$/\1$(version)">/' \
 		$@
 
 mandos: Makefile
@@ -164,7 +165,7 @@
 		--expression='s/^\(VERSION="\)[^"]*"$$/\1$(version)"/' \
 		$@
 
-mandos-list: Makefile
+mandos-ctl: Makefile
 	$(SED) --in-place \
 		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
 		$@
@@ -203,7 +204,8 @@
 run-client: all keydir/seckey.txt keydir/pubkey.txt
 	./plugin-runner --plugin-dir=plugins.d \
 		--config-file=plugin-runner.conf \
-		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt
+		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt \
+		$(CLIENTARGS)
 
 # Used by run-client
 keydir/seckey.txt keydir/pubkey.txt: mandos-keygen
@@ -212,7 +214,7 @@
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf
-	./mandos --debug --configdir=confdir
+	./mandos --debug --no-dbus --configdir=confdir $(SERVERARGS)
 
 # Used by run-server
 confdir/mandos.conf: mandos.conf
@@ -284,7 +286,7 @@
 	install --mode=u=rw,go=r initramfs-tools-hook-conf \
 		$(INITRAMFSTOOLS)/conf-hooks.d/mandos
 	install initramfs-tools-script \
-		$(INITRAMFSTOOLS)/scripts/local-top/mandos
+		$(INITRAMFSTOOLS)/scripts/init-premount/mandos
 	install --mode=u=rw,go=r plugin-runner.conf $(CONFDIR)
 	gzip --best --to-stdout mandos-keygen.8 \
 		> $(MANDIR)/man8/mandos-keygen.8.gz
@@ -331,7 +333,7 @@
 		$(PREFIX)/lib/mandos/plugins.d/askpass-fifo \
 		$(INITRAMFSTOOLS)/hooks/mandos \
 		$(INITRAMFSTOOLS)/conf-hooks.d/mandos \
-		$(INITRAMFSTOOLS)/scripts/local-top/mandos \
+		$(INITRAMFSTOOLS)/scripts/init-premount/mandos \
 		$(MANDIR)/man8/plugin-runner.8mandos.gz \
 		$(MANDIR)/man8/mandos-keygen.8.gz \
 		$(MANDIR)/man8/password-prompt.8mandos.gz \

=== modified file 'NEWS'
--- NEWS	2009-01-06 02:42:53 +0000
+++ NEWS	2009-02-25 01:31:13 +0000
@@ -1,6 +1,58 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
+Version 1.0.8 (2009-02-25)
+* Client
+** Bug fix: Fix missing quote characters in initramfs-tools-hook.
+
+Version 1.0.7 (2009-02-24)
+* Client
+** Bug fix: Do not depend on GNU awk.
+
+Version 1.0.6 (2009-02-13)
+* Server
+** Fix bug where server would stop responding, with a zombie checker
+** Support for disabling IPv6 (only for advanced users)
+** Fix bug which made server not change group ID
+
+* Client
+** Bug fix: Fix permission for /lib64 (on relevant architechtures).
+** Add support for IPv4 addresses.
+** Add support in mandos-client for not bringing up a network
+   interface by specifying an empty string to "--interface".
+** Make password prompt on boot not be mangled by kernel log messages
+   about network interface.
+** Get network interface from initramfs.conf and/or from kernel
+   command line.
+** If set by "ip=" kernel command line, configure network on boot.
+** Support connecting directly using "mandos=connect" kernel command.
+   line option, provided network is configured using "ip=".
+** Fix bug which made plugin-runner and mandos-client not change group
+   ID.
+** Fix bug where the "--options-for" option of plugin-runner would
+   truncate the value at the first colon character.
+** Fix bug where plugin-runner would not go to fallback if all plugins
+   failed.
+** Fix bug where mandos-client would not clean temporary directory on
+   a signal or on certain file systems.
+** Bug fix: remove bashism in /bin/sh script "mandos-keygen".
+
+Version 1.0.5 (2009-01-17)
+* Client
+** Fix small memory leak in plugin-runner.
+
+Version 1.0.4 (2009-01-15)
+* Server
+** Only find matched user/group pairs when searching for suitable
+   nonprivileged user/group to switch to.
+
+* Client
+** New kernel parameter "mandos=off" makes client not run at boot.
+** Fix linking errors and compilation warnings on AMD64.
+** Parse numbers in command line options better.
+** The splashy and usplash plugins are more robust while traversing
+   /proc, and will not abort if a process suddenly disappears.
+
 Version 1.0.3 (2009-01-06)
 * Server
 ** Now tries to change to user and group "_mandos" before falling back

=== modified file 'README'
--- README	2009-01-04 21:54:55 +0000
+++ README	2009-02-23 11:52:42 +0000
@@ -134,13 +134,15 @@
   In the early designs, the mandos-client(8mandos) program (which
   retrieves a password from the Mandos server) also prompted for a
   password on the terminal, in case a Mandos server could not be
-  found.  This duality of purpose was seen to be too complex to be a
-  viable way to continue.  Instead, the programs are now separated
-  into mandos-client(8mandos) and password-prompt(8mandos), and a
-  plugin-runner(8mandos) exist to run them both in parallel, allowing
-  the first plugin to succeed to provide the password.  This opened up
-  for any number of additional plugins to run, all competing to be the
-  first to find a password and provide it to the plugin runner.
+  found.  Other ways of retrieving a password could easily be
+  envisoned, but this multiplicity of purpose was seen to be too
+  complex to be a viable way to continue.  Instead, the original
+  program was separated into mandos-client(8mandos) and
+  password-prompt(8mandos), and a plugin-runner(8mandos) exist to run
+  them both in parallel, allowing the first successful plugin to
+  provide the password.  This opened up for any number of additional
+  plugins to run, all competing to be the first to find a password and
+  provide it to the plugin runner.
   
   Three additional plugins are provided:
   * usplash(8mandos)
@@ -152,9 +154,7 @@
     cryptsetup, this plugin listens to the same FIFO as askpass would
     do.
   
-  (None of these take any options or reads any files.)
-  
-  More plugins could easily be written and added by the system
+  More plugins can easily be written and added by the system
   administrator; see the section called "WRITING PLUGINS" in
   plugin-runner(8mandos) to learn the plugin requirements.
 

=== modified file 'TODO'
--- TODO	2008-12-29 02:44:54 +0000
+++ TODO	2009-02-09 19:26:19 +0000
@@ -1,64 +1,53 @@
 -*- org -*-
 
 * mandos-client
-** TODO [#B] Temporarily lower kernel log level
-   for less printouts during sucessfull boot.
-   klogctl(6, NULL, 0); klogctl(7, NULL, 0);
-** TODO [#C] IPv4 support
+** TODO [#A] Clean up /tmp directory on signal
 
 * plugin-runner
 ** TODO [#B] use scandir(3) instead of readdir(3)
 
 * mandos (server)
-** TODO [#B] Log level				:bugs:
+** TODO [#B] Log level				:BUGS:
 ** TODO /etc/mandos/clients.d/*.conf
    Watch this directory and add/remove/update clients?
 ** TODO config for TXT record
-** TODO [#B] Run-time communication with server :bugs:
+** TODO [#B] Run-time communication with server :BUGS:
    Probably using D-Bus
-   See also [[*Mandos-tools]]
 *** Client class
 *** Main server
     + SetLogLevel
       syslogger.setLevel(logging.WARNING)
-    + Quit
     + [[http://log.ometer.com/2007-05.html][Best D-Bus practices]]
-** TODO Implement --foreground			:bugs:
+** TODO Implement --foreground			:BUGS:
    [[info:standards:Option%20Table][Table of Long Options]]
 ** TODO Implement --socket
    [[info:standards:Option%20Table][Table of Long Options]]
-** TODO Date+time on console log messages	:bugs:
+** TODO Date+time on console log messages	:BUGS:
    Is this the default?
-** TODO delete hook when clients fall out by timeout
-   This will not be strictly necessary when the D-Bus interface is
-   implemented.
 
 * mandos.xml
 ** [[file:mandos.xml::XXX][Document D-Bus interface]]
 
 * Provide and install /etc/dbus-1/system.d/mandos.conf
 
-* mandos-list
+* mandos-ctl
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
-** TODO Disable client
-** TODO Enable client
-** TODO Reset timer
 
 * Curses interface
 
 * mandos-keygen
+** TODO Loop until passwords match when run interactively
 ** TODO "--secfile" option
    Using the "secfile" option instead of "secret"
 ** TODO [#B] "--test" option
    For testing decryption before rebooting.
 
-* [#A] Package
+* Package
 ** /usr/share/initramfs-tools/hooks/mandos
-*** TODO Do not install in initrd.img if configured not to.
-    Use "/etc/initramfs-tools/conf.d/mandos"?  Definitely a debconf
-    question.
-** TODO /etc/bash_completion.d/mandos
+*** TODO [#C] Do not install in initrd.img if configured not to.
+    Use "/etc/initramfs-tools/hooksconf.d/mandos"?
+** TODO [#C] /etc/bash_completion.d/mandos
    From XML sources directly?
 
 

=== modified file 'common.ent'
--- common.ent	2008-09-30 07:23:39 +0000
+++ common.ent	2009-02-25 01:31:13 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.0">
+<!ENTITY version "1.0.8">

=== modified file 'debian/changelog'
--- debian/changelog	2009-01-06 22:43:19 +0000
+++ debian/changelog	2009-02-25 01:31:13 +0000
@@ -1,3 +1,53 @@
+mandos (1.0.8-1) unstable; urgency=low
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Wed, 25 Feb 2009 02:26:57 +0100
+
+mandos (1.0.7-1) unstable; urgency=low
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Tue, 24 Feb 2009 12:58:06 +0100
+
+mandos (1.0.6-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/mandos-client.postinst: Converted to Bourne shell.  Also
+    minor message change.
+  * debian/mandos-client.postrm: Minor message change.
+  * debian/mandos.postinst: Converted to Bourne shell.  Also minor
+    message change.
+  * debian/mandos.prerm: Minor message change.
+  * debian/rules (install-indep): Removed "--no-start" from
+    dh_installinit.
+  * debian/mandos-client.lintian-overrides: Remove obsolete override for
+    unbreakable line in plugin-runner manual page.
+  * debian/control (mandos/Depends): Added "python-gobject".
+  * debian/mandos-client.dirs: Change
+    "usr/share/initramfs-tools/scripts/local-top" to
+    "usr/share/initramfs-tools/scripts/init-premount".
+  * debian/mandos-client.README.Debian: Add reference to initramfs.conf
+    and nfsroot.txt.  New section about the new non-local connection
+    feature.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Fri, 13 Feb 2009 09:27:25 +0100
+
+mandos (1.0.5-1) unstable; urgency=low
+
+  * New upstream release.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Sat, 17 Jan 2009 02:26:00 +0100
+
+mandos (1.0.4-1) unstable; urgency=low
+
+  * New upstream release.
+  * debian/watch: New file.
+  * debian/mandos-client.README.Debian: Document new "mandos=off" kernel
+    parameter.
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>  Thu, 15 Jan 2009 05:49:22 +0100
+
 mandos (1.0.3-2) unstable; urgency=low
 
   * Removed some now-unused debconf files.

=== modified file 'debian/control'
--- debian/control	2009-01-06 20:39:35 +0000
+++ debian/control	2009-01-26 23:47:44 +0000
@@ -15,7 +15,8 @@
 Package: mandos
 Architecture: all
 Depends: ${misc:Depends}, python (>=2.5), python-gnutls, python-dbus,
-	python-avahi, avahi-daemon, gnupg (< 2), adduser
+	python-avahi, python-gobject, avahi-daemon, gnupg (< 2),
+	adduser
 Recommends: fping
 Description: a server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows

=== modified file 'debian/mandos-client.README.Debian'
--- debian/mandos-client.README.Debian	2008-10-05 17:38:31 +0000
+++ debian/mandos-client.README.Debian	2009-02-09 02:01:13 +0000
@@ -7,10 +7,13 @@
 
 * Use the Correct Network Interface
   
-  If some other network interface than "eth0" is used, it will be
-  necessary to edit /etc/mandos/plugin-runner.conf to uncomment and
-  change the line there.  If this is done, it will be necessary to
-  update the initrd image by doing "update-initramfs -k all -u".
+  Make sure that the correct network interface is specified in the
+  DEVICE setting in the "/etc/initramfs-tools/initramfs.conf" file.
+  If this is changed, it will be necessary to update the initrd image
+  by doing "update-initramfs -k all -u".  This setting can be
+  overridden at boot time on the Linux kernel command line using the
+  sixth colon-separated field of the "ip=" option; for exact syntax,
+  see the file "Documentation/nfsroot.txt" in the Linux source tree.
 
 * Test the Server
   
@@ -23,23 +26,47 @@
 		--seckey=/etc/keys/mandos/seckey.txt; echo
   
   This command should retrieve the password from the server, decrypt
-  it, and output it to standard output.  It is now possible to verify
-  the correctness of the password before rebooting.
+  it, and output it to standard output.  There it can be verified to
+  be the correct password, before rebooting.
 
 * User-Supplied Plugins
-
+  
   Any plugins found in /etc/mandos/plugins.d will override and add to
   the normal Mandos plugins.  When adding or changing plugins, do not
   forget to update the initital RAM disk image:
-
+  
 	# update-initramfs -k all -u
 
 * Do *NOT* Edit /etc/crypttab
-
+  
   It is NOT necessary to edit /etc/crypttab to specify
   /usr/lib/mandos/plugin-runner as a keyscript for the root file
   system; if no keyscript is given for the root file system, the
   Mandos client will be the new default way for getting a password for
   the root file system when booting.
 
- -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Sun,  5 Oct 2008 19:04:26 +0200
+* Emergency Escape
+  
+  If it ever should be necessary, the Mandos client can be temporarily
+  prevented from running at startup by passing the parameter
+  "mandos=off" to the kernel.
+
+* Non-local Connection (Not Using ZeroConf)
+  
+  If the "ip=" kernel command line option is used to specify a
+  complete IP address and device name, as noted above, it then becomes
+  possible to specify a specific IP address and port to connect to,
+  instead of using ZeroConf.  The syntax for doing this is
+  "mandos=connect:<IP_ADDRESS>:<PORT_NUMBER>".
+  
+  Warning: this will cause the client to make exactly one attempt at
+  connecting, and then fail if it does not succeed.
+  
+  For very advanced users, it it possible to specify simply
+  "mandos=connect" on the kernel command line to make the system only
+  set up the network (using the data in the "ip=" option) and not pass
+  any extra "--connect" options to mandos-client at boot.  For this to
+  work, "--options-for=mandos-client:--connect=<ADDRESS>:<PORT>" needs
+  to be manually added to the file "/etc/mandos/plugin-runner.conf".
+
+ -- Teddy Hogeborn <teddy@fukt.bsnet.se>, Mon,  9 Feb 2009 00:36:55 +0100

=== modified file 'debian/mandos-client.dirs'
--- debian/mandos-client.dirs	2008-09-17 00:34:09 +0000
+++ debian/mandos-client.dirs	2009-02-07 04:50:39 +0000
@@ -2,4 +2,4 @@
 usr/sbin
 usr/share/initramfs-tools/hooks
 usr/share/initramfs-tools/conf-hooks.d
-usr/share/initramfs-tools/scripts/local-top
+usr/share/initramfs-tools/scripts/init-premount

=== modified file 'debian/mandos-client.lintian-overrides'
--- debian/mandos-client.lintian-overrides	2008-10-01 15:29:01 +0000
+++ debian/mandos-client.lintian-overrides	2009-01-18 06:41:57 +0000
@@ -1,8 +1,3 @@
-# This example command line is long without spaces, but it must be
-# that way; it's part of the point of showing it.
-#
-mandos-client binary: manpage-has-errors-from-man usr/share/man/man8/plugin-runner.8mandos.gz 297: warning [p 4, 5.8i]: can't break line
-
 # This directory contains secret client key files.
 #
 mandos-client binary: non-standard-dir-perm etc/keys/mandos/ 0700 != 0755
@@ -16,7 +11,7 @@
 
 # These binaries must be setuid root, since they need root powers, but
 # are started by plugin-runner(8mandos), which runs all plugins as
-# user/group "mandos".  These binaries are not run in a running
+# user/group "_mandos".  These binaries are not run in a running
 # system, but in an initial RAM disk environment.  Here they are
 # protected from non-root access by the directory permissions, above.
 #

=== modified file 'debian/mandos-client.postinst'
--- debian/mandos-client.postinst	2009-01-06 05:08:37 +0000
+++ debian/mandos-client.postinst	2009-01-18 00:16:57 +0000
@@ -1,4 +1,4 @@
-#!/bin/bash -e
+#!/bin/sh -e
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -26,7 +26,7 @@
 # Add user and group
 add_mandos_user(){
     # Rename old "mandos" user and group
-    case "$(getent passwd mandos)" in
+    case "`getent passwd mandos`" in
 	*:Mandos\ password\ system,,,:/nonexistent:/bin/false)
 	    usermod --login _mandos mandos
 	    groupmod --new-name _mandos mandos
@@ -62,7 +62,7 @@
 	;;
 
     *)
-	echo "$0 called with unknown argument \`$1'" 1>&2
+	echo "$0 called with unknown argument '$1'" 1>&2
 	exit 1
 	;;
 esac

=== modified file 'debian/mandos-client.postrm'
--- debian/mandos-client.postrm	2008-09-19 20:54:58 +0000
+++ debian/mandos-client.postrm	2009-01-18 00:16:57 +0000
@@ -50,7 +50,7 @@
 	;;
 
     *)
-	echo "$0 called with unknown argument \`$1'" 1>&2
+	echo "$0 called with unknown argument '$1'" 1>&2
 	exit 1
 	;;
 esac

=== modified file 'debian/mandos.postinst'
--- debian/mandos.postinst	2009-01-06 05:08:37 +0000
+++ debian/mandos.postinst	2009-01-18 00:16:57 +0000
@@ -1,4 +1,4 @@
-#!/bin/bash -e
+#!/bin/sh -e
 # This script can be called in the following ways:
 #
 # After the package was installed:
@@ -18,7 +18,7 @@
 case "$1" in
     configure)
 	# Rename old "mandos" user and group
-	case "$(getent passwd mandos)" in
+	case "`getent passwd mandos`" in
 	    *:Mandos\ password\ system,,,:/nonexistent:/bin/false)
 		usermod --login _mandos mandos
 		groupmod --new-name _mandos mandos
@@ -37,7 +37,7 @@
 	;;
 
     *)
-	echo "$0 called with unknown argument \`$1'" 1>&2
+	echo "$0 called with unknown argument '$1'" 1>&2
 	exit 1
 	;;
 esac

=== modified file 'debian/mandos.prerm'
--- debian/mandos.prerm	2008-09-21 13:42:34 +0000
+++ debian/mandos.prerm	2009-01-18 00:16:57 +0000
@@ -6,12 +6,12 @@
 set -e
 
 # summary of how this script can be called:
-#        * <prerm> `remove'
-#        * <old-prerm> `upgrade' <new-version>
-#        * <new-prerm> `failed-upgrade' <old-version>
-#        * <conflictor's-prerm> `remove' `in-favour' <package> <new-version>
-#        * <deconfigured's-prerm> `deconfigure' `in-favour'
-#          <package-being-installed> <version> `removing'
+#        * <prerm> 'remove'
+#        * <old-prerm> 'upgrade' <new-version>
+#        * <new-prerm> 'failed-upgrade' <old-version>
+#        * <conflictor's-prerm> 'remove' 'in-favour' <package> <new-version>
+#        * <deconfigured's-prerm> 'deconfigure' 'in-favour'
+#          <package-being-installed> <version> 'removing'
 #          <conflicting-package> <version>
 # for details, see /usr/share/doc/packaging-manual/
 
@@ -28,7 +28,7 @@
     upgrade|failed-upgrade)
         ;;
     *)
-        echo "prerm called with unknown argument \`$1'" >&2
+        echo "prerm called with unknown argument '$1'" >&2
         exit 0
     ;;
 esac

=== modified file 'debian/rules'
--- debian/rules	2009-01-04 22:26:07 +0000
+++ debian/rules	2009-01-18 00:18:50 +0000
@@ -47,7 +47,7 @@
 	dh_installdirs --indep
 	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos install-server
 	dh_lintian
-	dh_installinit --onlyscripts --no-start \
+	dh_installinit --onlyscripts \
 		--update-rcd-params="defaults 25 15"
 	dh_install --indep
 

=== added file 'debian/watch'
--- debian/watch	1970-01-01 00:00:00 +0000
+++ debian/watch	2009-01-15 02:52:02 +0000
@@ -0,0 +1,2 @@
+version=3
+ftp://ftp.fukt.bsnet.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z)

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2008-12-10 01:26:02 +0000
+++ initramfs-tools-hook	2009-02-25 01:14:29 +0000
@@ -55,12 +55,12 @@
 		|| getent passwd mandos \
 		|| getent passwd nobody \
 		|| echo ::65534::::; } \
-	| awk --field-separator=: '{ print $3 }'`" 
+	| cut --delimiter=: --fields=3 --only-delimited`"
 mandos_group="`{ getent group _mandos \
 		|| getent group mandos \
 		|| getent group nogroup \
 		|| echo ::65534:; } \
-	| awk --field-separator=: '{ print $3 }'`"
+	| cut --delimiter=: --fields=3 --only-delimited`"
 
 # The Mandos network client uses the network
 auto_add_modules net
@@ -92,8 +92,8 @@
     fi
     case "$base" in
 	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert) : ;;
-	"*") :;;
-	*) copy_exec "$file" "${PLUGINDIR}";;
+	"*") : ;;
+	*) copy_exec "$file" "${PLUGINDIR}" ;;
     esac
 done
 
@@ -102,8 +102,8 @@
     base="`basename \"$file\"`"
     case "$base" in
 	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert) : ;;
-	"*") :;;
-	*) copy_exec "$file" "${PLUGINDIR}";;
+	"*") : ;;
+	*) copy_exec "$file" "${PLUGINDIR}" ;;
     esac
 done
 
@@ -124,16 +124,22 @@
 
 if [ ${mandos_user} != 65534 ]; then
     PLUGINRUNNERCONF="${DESTDIR}${CONFDIR}/plugin-runner.conf"
-    echo "--userid=${mandos_user}" >> "$PLUGINRUNNERCONF"
+    cat <<-EOF >> "$PLUGINRUNNERCONF"
+	
+	--userid=${mandos_user}
+EOF
 fi
 
 if [ ${mandos_group} != 65534 ]; then
     PLUGINRUNNERCONF="${DESTDIR}${CONFDIR}/plugin-runner.conf"
-    echo "--groupid=${mandos_group}" >> "$PLUGINRUNNERCONF"
+    cat <<-EOF >> "$PLUGINRUNNERCONF"
+	
+	--groupid=${mandos_group}
+EOF
 fi
 
 # Key files 
-for file in  "$keydir"/*; do
+for file in "$keydir"/*; do
     if [ -d "$file" ]; then
 	continue
     fi
@@ -168,7 +174,9 @@
 	chmod a+rX "${DESTDIR}$dir"
     fi
 done
-for dir in /lib /usr/lib; do
-    find "${DESTDIR}$dir" \! -perm -u+rw,g+r -prune -or -print0 \
-	| xargs --null --no-run-if-empty chmod a+rX
+for dir in "${DESTDIR}"/lib* "${DESTDIR}"/usr/lib*; do
+    if [ -d "$dir" ]; then
+	find "$dir" \! -perm -u+rw,g+r -prune -or -print0 \
+	    | xargs --null --no-run-if-empty chmod a+rX
+    fi
 done

=== modified file 'initramfs-tools-hook-conf'
--- initramfs-tools-hook-conf	2008-08-12 19:22:34 +0000
+++ initramfs-tools-hook-conf	2009-05-17 00:50:09 +0000
@@ -1,1 +1,13 @@
+# -*- shell-script -*-
+
+# if mkinitramfs is started by mkinitramfs-kpkg, mkinitramfs-kpkg has
+# already touched the initrd file with umask 022 before we had a
+# chance to affect it.  We cannot allow a readable initrd file,
+# therefore we must fix this now.
+if [ -e "${outfile}" ] \
+    && [ `stat --format=%s "${outfile}"` -eq 0 ]; then
+    rm "${outfile}"
+    (umask 027; touch "${outfile}")
+fi
+
 UMASK=027

=== modified file 'initramfs-tools-script'
--- initramfs-tools-script	2008-09-07 15:42:11 +0000
+++ initramfs-tools-script	2009-02-09 02:01:13 +0000
@@ -6,27 +6,103 @@
 # 
 
 # This script should be installed as
-# "/usr/share/initramfs-tools/scripts/local-top/mandos" which will
-# eventually be "/scripts/local-top/mandos" in the initrd.img file.
+# "/usr/share/initramfs-tools/scripts/init-premount/mandos" which will
+# eventually be "/scripts/init-premount/mandos" in the initrd.img
+# file.
 
-# No initramfs pre-requirements; we must instead run BEFORE cryptroot.
-# This is not a problem, since cryptroot forces itself to run LAST.
-PREREQ=""
+# No initramfs pre-requirements.
+PREREQ="udev"
 prereqs()
 {
-     echo "$PREREQ"
+    echo "$PREREQ"
 }
 
 case $1 in
 prereqs)
-     prereqs
-     exit 0
-     ;;
+	prereqs
+	exit 0
+	;;
 esac
 
+. /scripts/functions
+
+for param in `cat /proc/cmdline`; do
+    case "$param" in
+        ip=*) IPOPTS="${param#ip=}" ;;
+        mandos=*)
+            # Split option line on commas
+            old_ifs="$IFS"
+            IFS="$IFS,"
+            for mpar in ${param#mandos=}; do
+                IFS="$old_ifs"
+                case "$mpar" in
+                    off) exit 0 ;;
+		    connect) connect="" ;;
+                    connect:*) connect="${mpar#connect:}" ;;
+                    *) log_warning_msg "$0: Bad option ${mpar}" ;;
+                esac
+            done
+	    unset mpar
+            IFS="$old_ifs"
+            unset old_ifs
+            ;;
+    esac
+done
+unset param
+
 chmod a=rwxt /tmp
 
-test -w /conf/conf.d/cryptroot
+test -r /conf/conf.d/cryptroot
+test -w /conf/conf.d
+
+# Get DEVICE from /conf/initramfs.conf and other files
+. /conf/initramfs.conf
+for conf in /conf/conf.d/*; do
+    [ -f ${conf} ] && . ${conf}
+done
+if [ -e /conf/param.conf ]; then
+    . /conf/param.conf
+fi
+
+# Override DEVICE from sixth field of ip= kernel option, if passed
+case "$IPOPTS" in
+    *:*:*:*:*:*)		# At least six fields
+        # Remove the first five fields
+	device="${IPOPTS#*:*:*:*:*:}"
+        # Remove all fields except the first one
+	DEVICE="${device%%:*}"
+	;;
+esac
+
+# Add device setting (if any) to plugin-runner.conf
+if [ "${DEVICE+set}" = set ]; then
+    # Did we get the device from an ip= option?
+    if [ "${device+set}" = set ]; then
+	# Let ip= option override local config; append:
+	cat <<-EOF >>/conf/conf.d/mandos/plugin-runner.conf
+	
+	--options-for=mandos-client:--interface=${DEVICE}
+EOF
+    else
+        # Prepend device setting so any later options would override:
+	sed -i -e \
+	    '1i--options-for=mandos-client:--interface='"${DEVICE}" \
+	    /conf/conf.d/mandos/plugin-runner.conf
+    fi
+fi
+unset device
+
+# If we are connecting directly, run "configure_networking" (from
+# /scripts/functions); it needs IPOPTS and DEVICE
+if [ "${connect+set}" = set ]; then
+    configure_networking
+    if [ -n "$connect" ]; then
+	cat <<-EOF >>/conf/conf.d/mandos/plugin-runner.conf
+	
+	--options-for=mandos-client:--connect=${connect}
+EOF
+    fi
+fi
 
 # Do not replace cryptroot file unless we need to.
 replace_cryptroot=no

=== modified file 'mandos'
--- mandos	2009-01-08 03:54:06 +0000
+++ mandos	2009-02-25 01:31:13 +0000
@@ -35,7 +35,7 @@
 
 import SocketServer
 import socket
-from optparse import OptionParser
+import optparse
 import datetime
 import errno
 import gnutls.crypto
@@ -66,19 +66,20 @@
 import ctypes
 import ctypes.util
 
-version = "1.0.3"
+version = "1.0.8"
 
 logger = logging.Logger('mandos')
 syslogger = (logging.handlers.SysLogHandler
              (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
               address = "/dev/log"))
 syslogger.setFormatter(logging.Formatter
-                       ('Mandos: %(levelname)s: %(message)s'))
+                       ('Mandos [%(process)d]: %(levelname)s:'
+                        ' %(message)s'))
 logger.addHandler(syslogger)
 
 console = logging.StreamHandler()
-console.setFormatter(logging.Formatter('%(name)s: %(levelname)s:'
-                                       ' %(message)s'))
+console.setFormatter(logging.Formatter('%(name)s [%(process)d]:'
+                                       ' %(levelname)s: %(message)s'))
 logger.addHandler(console)
 
 class AvahiError(Exception):
@@ -113,7 +114,8 @@
     """
     def __init__(self, interface = avahi.IF_UNSPEC, name = None,
                  servicetype = None, port = None, TXT = None,
-                 domain = "", host = "", max_renames = 32768):
+                 domain = "", host = "", max_renames = 32768,
+                 protocol = avahi.PROTO_UNSPEC):
         self.interface = interface
         self.name = name
         self.type = servicetype
@@ -123,6 +125,7 @@
         self.host = host
         self.rename_count = 0
         self.max_renames = max_renames
+        self.protocol = protocol
     def rename(self):
         """Derived from the Avahi example code"""
         if self.rename_count >= self.max_renames:
@@ -157,7 +160,7 @@
                      service.name, service.type)
         group.AddService(
                 self.interface,         # interface
-                avahi.PROTO_INET6,      # protocol
+                self.protocol,          # protocol
                 dbus.UInt32(0),         # flags
                 self.name, self.type,
                 self.domain, self.host,
@@ -178,7 +181,8 @@
 class Client(dbus.service.Object):
     """A representation of a client host served by this server.
     Attributes:
-    name:       string; from the config file, used in log messages
+    name:       string; from the config file, used in log messages and
+                        D-Bus identifiers
     fingerprint: string (40 or 32 hexadecimal digits); used to
                  uniquely identify the client
     secret:     bytestring; sent verbatim (over TLS) to client
@@ -201,6 +205,7 @@
                      client lives.  %() expansions are done at
                      runtime with vars(self) as dict, so that for
                      instance %(name)s can be used in the command.
+    current_checker_command: string; current running checker_command
     use_dbus: bool(); Whether to provide D-Bus interface and signals
     dbus_object_path: dbus.ObjectPath ; only set if self.use_dbus
     """
@@ -225,13 +230,7 @@
         if config is None:
             config = {}
         logger.debug(u"Creating client %r", self.name)
-        self.use_dbus = use_dbus
-        if self.use_dbus:
-            self.dbus_object_path = (dbus.ObjectPath
-                                     ("/Mandos/clients/"
-                                      + self.name.replace(".", "_")))
-            dbus.service.Object.__init__(self, bus,
-                                         self.dbus_object_path)
+        self.use_dbus = False   # During __init__
         # Uppercase and remove spaces from fingerprint for later
         # comparison purposes with return value from the fingerprint()
         # function
@@ -261,6 +260,17 @@
         self.disable_initiator_tag = None
         self.checker_callback_tag = None
         self.checker_command = config["checker"]
+        self.current_checker_command = None
+        self.last_connect = None
+        # Only now, when this client is initialized, can it show up on
+        # the D-Bus
+        self.use_dbus = use_dbus
+        if self.use_dbus:
+            self.dbus_object_path = (dbus.ObjectPath
+                                     ("/clients/"
+                                      + self.name.replace(".", "_")))
+            dbus.service.Object.__init__(self, bus,
+                                         self.dbus_object_path)
     
     def enable(self):
         """Start this client's checker and timeout hooks"""
@@ -319,34 +329,30 @@
             # Emit D-Bus signal
             self.PropertyChanged(dbus.String(u"checker_running"),
                                  dbus.Boolean(False, variant_level=1))
-        if (os.WIFEXITED(condition)
-            and (os.WEXITSTATUS(condition) == 0)):
-            logger.info(u"Checker for %(name)s succeeded",
-                        vars(self))
+        if os.WIFEXITED(condition):
+            exitstatus = os.WEXITSTATUS(condition)
+            if exitstatus == 0:
+                logger.info(u"Checker for %(name)s succeeded",
+                            vars(self))
+                self.checked_ok()
+            else:
+                logger.info(u"Checker for %(name)s failed",
+                            vars(self))
             if self.use_dbus:
                 # Emit D-Bus signal
-                self.CheckerCompleted(dbus.Boolean(True),
-                                      dbus.UInt16(condition),
+                self.CheckerCompleted(dbus.Int16(exitstatus),
+                                      dbus.Int64(condition),
                                       dbus.String(command))
-            self.bump_timeout()
-        elif not os.WIFEXITED(condition):
+        else:
             logger.warning(u"Checker for %(name)s crashed?",
                            vars(self))
             if self.use_dbus:
                 # Emit D-Bus signal
-                self.CheckerCompleted(dbus.Boolean(False),
-                                      dbus.UInt16(condition),
-                                      dbus.String(command))
-        else:
-            logger.info(u"Checker for %(name)s failed",
-                        vars(self))
-            if self.use_dbus:
-                # Emit D-Bus signal
-                self.CheckerCompleted(dbus.Boolean(False),
-                                      dbus.UInt16(condition),
+                self.CheckerCompleted(dbus.Int16(-1),
+                                      dbus.Int64(condition),
                                       dbus.String(command))
     
-    def bump_timeout(self):
+    def checked_ok(self):
         """Bump up the timeout for this client.
         This should only be called when the client has been seen,
         alive and well.
@@ -375,6 +381,16 @@
         # checkers alone, the checker would have to take more time
         # than 'timeout' for the client to be declared invalid, which
         # is as it should be.
+        
+        # If a checker exists, make sure it is not a zombie
+        if self.checker is not None:
+            pid, status = os.waitpid(self.checker.pid, os.WNOHANG)
+            if pid:
+                logger.warning("Checker was a zombie")
+                gobject.source_remove(self.checker_callback_tag)
+                self.checker_callback(pid, status,
+                                      self.current_checker_command)
+        # Start a new checker if needed
         if self.checker is None:
             try:
                 # In case checker_command has exactly one % operator
@@ -390,6 +406,7 @@
                     logger.error(u'Could not format string "%s":'
                                  u' %s', self.checker_command, error)
                     return True # Try again later
+                self.current_checker_command = command
             try:
                 logger.info(u"Starting checker %r for %s",
                             command, self.name)
@@ -410,6 +427,12 @@
                                              (self.checker.pid,
                                               self.checker_callback,
                                               data=command))
+                # The checker may have completed before the gobject
+                # watch was added.  Check for this.
+                pid, status = os.waitpid(self.checker.pid, os.WNOHANG)
+                if pid:
+                    gobject.source_remove(self.checker_callback_tag)
+                    self.checker_callback(pid, status, command)
             except OSError, error:
                 logger.error(u"Failed to start subprocess: %s",
                              error)
@@ -448,15 +471,15 @@
             return now < (self.last_checked_ok + self.timeout)
     
     ## D-Bus methods & signals
-    _interface = u"org.mandos_system.Mandos.Client"
+    _interface = u"se.bsnet.fukt.Mandos.Client"
     
-    # BumpTimeout - method
-    BumpTimeout = dbus.service.method(_interface)(bump_timeout)
-    BumpTimeout.__name__ = "BumpTimeout"
+    # CheckedOK - method
+    CheckedOK = dbus.service.method(_interface)(checked_ok)
+    CheckedOK.__name__ = "CheckedOK"
     
     # CheckerCompleted - signal
-    @dbus.service.signal(_interface, signature="bqs")
-    def CheckerCompleted(self, success, condition, command):
+    @dbus.service.signal(_interface, signature="nxs")
+    def CheckerCompleted(self, exitcode, waitstatus, command):
         "D-Bus signal"
         pass
     
@@ -503,6 +526,9 @@
                 dbus.String("checker_running"):
                     dbus.Boolean(self.checker is not None,
                                  variant_level=1),
+                dbus.String("object_path"):
+                    dbus.ObjectPath(self.dbus_object_path,
+                                    variant_level=1)
                 }, signature="sv")
     
     # IsStillValid - method
@@ -591,10 +617,13 @@
         != gnutls.library.constants.GNUTLS_CRT_OPENPGP):
         # ...do the normal thing
         return session.peer_certificate
-    list_size = ctypes.c_uint()
+    list_size = ctypes.c_uint(1)
     cert_list = (gnutls.library.functions
                  .gnutls_certificate_get_peers
                  (session._c_object, ctypes.byref(list_size)))
+    if not bool(cert_list) and list_size.value != 0:
+        raise gnutls.errors.GNUTLSError("error getting peer"
+                                        " certificate")
     if list_size.value == 0:
         return None
     cert = cert_list[0]
@@ -669,8 +698,8 @@
         # using OpenPGP certificates.
         
         #priority = ':'.join(("NONE", "+VERS-TLS1.1", "+AES-256-CBC",
-        #                "+SHA1", "+COMP-NULL", "+CTYPE-OPENPGP",
-        #                "+DHE-DSS"))
+        #                     "+SHA1", "+COMP-NULL", "+CTYPE-OPENPGP",
+        #                     "+DHE-DSS"))
         # Use a fallback default, since this MUST be set.
         priority = self.server.settings.get("priority", "NORMAL")
         (gnutls.library.functions
@@ -684,6 +713,7 @@
             # Do not run session.bye() here: the session is not
             # established.  Just abandon the request.
             return
+        logger.debug(u"Handshake succeeded")
         try:
             fpr = fingerprint(peer_certificate(session))
         except (TypeError, gnutls.errors.GNUTLSError), error:
@@ -691,6 +721,7 @@
             session.bye()
             return
         logger.debug(u"Fingerprint: %s", fpr)
+        
         for c in self.server.clients:
             if c.fingerprint == fpr:
                 client = c
@@ -709,7 +740,7 @@
             session.bye()
             return
         ## This won't work here, since we're in a fork.
-        # client.bump_timeout()
+        # client.checked_ok()
         sent_size = 0
         while sent_size < len(client.secret):
             sent = session.send(client.secret[sent_size:])
@@ -722,7 +753,7 @@
 
 class IPv6_TCPServer(SocketServer.ForkingMixIn,
                      SocketServer.TCPServer, object):
-    """IPv6 TCP server.  Accepts 'None' as address and/or port.
+    """IPv6-capable TCP server.  Accepts 'None' as address and/or port
     Attributes:
         settings:       Server settings
         clients:        Set() of Client objects
@@ -736,6 +767,10 @@
         if "clients" in kwargs:
             self.clients = kwargs["clients"]
             del kwargs["clients"]
+        if "use_ipv6" in kwargs:
+            if not kwargs["use_ipv6"]:
+                self.address_family = socket.AF_INET
+            del kwargs["use_ipv6"]
         self.enabled = False
         super(IPv6_TCPServer, self).__init__(*args, **kwargs)
     def server_bind(self):
@@ -755,12 +790,15 @@
                                  u" bind to interface %s",
                                  self.settings["interface"])
                 else:
-                    raise error
+                    raise
         # Only bind(2) the socket if we really need to.
         if self.server_address[0] or self.server_address[1]:
             if not self.server_address[0]:
-                in6addr_any = "::"
-                self.server_address = (in6addr_any,
+                if self.address_family == socket.AF_INET6:
+                    any_address = "::" # in6addr_any
+                else:
+                    any_address = socket.INADDR_ANY
+                self.server_address = (any_address,
                                        self.server_address[1])
             elif not self.server_address[1]:
                 self.server_address = (self.server_address[0],
@@ -782,7 +820,7 @@
 
 def string_to_delta(interval):
     """Parse a string and return a datetime.timedelta
-
+    
     >>> string_to_delta('7d')
     datetime.timedelta(7)
     >>> string_to_delta('60s')
@@ -889,7 +927,7 @@
 
 
 def main():
-    parser = OptionParser(version = "%%prog %s" % version)
+    parser = optparse.OptionParser(version = "%%prog %s" % version)
     parser.add_option("-i", "--interface", type="string",
                       metavar="IF", help="Bind to interface IF")
     parser.add_option("-a", "--address", type="string",
@@ -911,8 +949,9 @@
                       " files")
     parser.add_option("--no-dbus", action="store_false",
                       dest="use_dbus",
-                      help="Do not provide D-Bus system bus"
-                      " interface")
+                      help=optparse.SUPPRESS_HELP) # XXX: Not done yet
+    parser.add_option("--no-ipv6", action="store_false",
+                      dest="use_ipv6", help="Do not use IPv6")
     options = parser.parse_args()[0]
     
     if options.check:
@@ -929,6 +968,7 @@
                         "SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP",
                         "servicename": "Mandos",
                         "use_dbus": "True",
+                        "use_ipv6": "True",
                         }
     
     # Parse config file for server-global settings
@@ -937,18 +977,23 @@
     server_config.read(os.path.join(options.configdir, "mandos.conf"))
     # Convert the SafeConfigParser object to a dict
     server_settings = server_config.defaults()
-    # Use getboolean on the boolean config options
-    server_settings["debug"] = (server_config.getboolean
-                                ("DEFAULT", "debug"))
-    server_settings["use_dbus"] = (server_config.getboolean
-                                   ("DEFAULT", "use_dbus"))
+    # Use the appropriate methods on the non-string config options
+    server_settings["debug"] = server_config.getboolean("DEFAULT",
+                                                        "debug")
+    server_settings["use_dbus"] = server_config.getboolean("DEFAULT",
+                                                           "use_dbus")
+    server_settings["use_ipv6"] = server_config.getboolean("DEFAULT",
+                                                           "use_ipv6")
+    if server_settings["port"]:
+        server_settings["port"] = server_config.getint("DEFAULT",
+                                                       "port")
     del server_config
     
     # Override the settings from the config file with command line
     # options, if set.
     for option in ("interface", "address", "port", "debug",
                    "priority", "servicename", "configdir",
-                   "use_dbus"):
+                   "use_dbus", "use_ipv6"):
         value = getattr(options, option)
         if value is not None:
             server_settings[option] = value
@@ -958,6 +1003,8 @@
     # For convenience
     debug = server_settings["debug"]
     use_dbus = server_settings["use_dbus"]
+    use_dbus = False            # XXX: Not done yet
+    use_ipv6 = server_settings["use_ipv6"]
     
     if not debug:
         syslogger.setLevel(logging.WARNING)
@@ -984,11 +1031,11 @@
                                  server_settings["port"]),
                                 TCP_handler,
                                 settings=server_settings,
-                                clients=clients)
+                                clients=clients, use_ipv6=use_ipv6)
     pidfilename = "/var/run/mandos.pid"
     try:
         pidfile = open(pidfilename, "w")
-    except IOError, error:
+    except IOError:
         logger.error("Could not open file %r", pidfilename)
     
     try:
@@ -1006,15 +1053,30 @@
                 uid = 65534
                 gid = 65534
     try:
+        os.setgid(gid)
         os.setuid(uid)
-        os.setgid(gid)
     except OSError, error:
         if error[0] != errno.EPERM:
             raise error
     
+    # Enable all possible GnuTLS debugging
+    if debug:
+        # "Use a log level over 10 to enable all debugging options."
+        # - GnuTLS manual
+        gnutls.library.functions.gnutls_global_set_log_level(11)
+        
+        @gnutls.library.types.gnutls_log_func
+        def debug_gnutls(level, string):
+            logger.debug("GnuTLS: %s", string[:-1])
+        
+        (gnutls.library.functions
+         .gnutls_global_set_log_function(debug_gnutls))
+    
     global service
+    protocol = avahi.PROTO_INET6 if use_ipv6 else avahi.PROTO_INET
     service = AvahiService(name = server_settings["servicename"],
-                           servicetype = "_mandos._tcp", )
+                           servicetype = "_mandos._tcp",
+                           protocol = protocol)
     if server_settings["interface"]:
         service.interface = (if_nametoindex
                              (server_settings["interface"]))
@@ -1031,8 +1093,7 @@
                             avahi.DBUS_INTERFACE_SERVER)
     # End of Avahi example code
     if use_dbus:
-        bus_name = dbus.service.BusName(u"org.mandos-system.Mandos",
-                                        bus)
+        bus_name = dbus.service.BusName(u"se.bsnet.fukt.Mandos", bus)
     
     clients.update(Set(Client(name = section,
                               config
@@ -1092,33 +1153,35 @@
         class MandosServer(dbus.service.Object):
             """A D-Bus proxy object"""
             def __init__(self):
-                dbus.service.Object.__init__(self, bus,
-                                             "/Mandos")
-            _interface = u"org.mandos_system.Mandos"
-
+                dbus.service.Object.__init__(self, bus, "/")
+            _interface = u"se.bsnet.fukt.Mandos"
+            
             @dbus.service.signal(_interface, signature="oa{sv}")
             def ClientAdded(self, objpath, properties):
                 "D-Bus signal"
                 pass
-
-            @dbus.service.signal(_interface, signature="o")
-            def ClientRemoved(self, objpath):
+            
+            @dbus.service.signal(_interface, signature="os")
+            def ClientRemoved(self, objpath, name):
                 "D-Bus signal"
                 pass
-
+            
             @dbus.service.method(_interface, out_signature="ao")
             def GetAllClients(self):
+                "D-Bus method"
                 return dbus.Array(c.dbus_object_path for c in clients)
-
+            
             @dbus.service.method(_interface, out_signature="a{oa{sv}}")
             def GetAllClientsWithProperties(self):
+                "D-Bus method"
                 return dbus.Dictionary(
                     ((c.dbus_object_path, c.GetAllProperties())
                      for c in clients),
                     signature="oa{sv}")
-
+            
             @dbus.service.method(_interface, in_signature="o")
             def RemoveClient(self, object_path):
+                "D-Bus method"
                 for c in clients:
                     if c.dbus_object_path == object_path:
                         clients.remove(c)
@@ -1126,15 +1189,12 @@
                         c.use_dbus = False
                         c.disable()
                         # Emit D-Bus signal
-                        self.ClientRemoved(object_path)
+                        self.ClientRemoved(object_path, c.name)
                         return
                 raise KeyError
-            @dbus.service.method(_interface)
-            def Quit(self):
-                main_loop.quit()
-
+            
             del _interface
-    
+        
         mandos_server = MandosServer()
     
     for client in clients:
@@ -1149,8 +1209,13 @@
     
     # Find out what port we got
     service.port = tcp_server.socket.getsockname()[1]
-    logger.info(u"Now listening on address %r, port %d, flowinfo %d,"
-                u" scope_id %d" % tcp_server.socket.getsockname())
+    if use_ipv6:
+        logger.info(u"Now listening on address %r, port %d,"
+                    " flowinfo %d, scope_id %d"
+                    % tcp_server.socket.getsockname())
+    else:                       # IPv4
+        logger.info(u"Now listening on address %r, port %d"
+                    % tcp_server.socket.getsockname())
     
     #service.interface = tcp_server.socket.getsockname()[3]
     
@@ -1176,7 +1241,9 @@
         sys.exit(1)
     except KeyboardInterrupt:
         if debug:
-            print
+            print >> sys.stderr
+        logger.debug("Server received KeyboardInterrupt")
+    logger.debug("Server exiting")
 
 if __name__ == '__main__':
     main()

=== modified file 'mandos-clients.conf.xml'
--- mandos-clients.conf.xml	2009-01-08 03:54:06 +0000
+++ mandos-clients.conf.xml	2009-02-15 09:09:27 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos-clients.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/clients.conf</filename>">
-<!ENTITY TIMESTAMP "2009-01-08">
+<!ENTITY TIMESTAMP "2009-02-15">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -257,7 +257,7 @@
 	    This option is <emphasis>optional</emphasis>, but highly
 	    <emphasis>recommended</emphasis> unless the
 	    <option>checker</option> option is modified to a
-	    non-standard value without <quote>%(host)s</quote> in it.
+	    non-standard value without <quote>%%(host)s</quote> in it.
 	  </para>
 	  <para>
 	    Host name for this client.  This is not used by the server

=== renamed file 'mandos-list' => 'mandos-ctl'
--- mandos-list	2008-12-21 19:19:25 +0000
+++ mandos-ctl	2009-02-25 01:31:13 +0000
@@ -1,9 +1,13 @@
 #!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
 
+from __future__ import division
+import sys
 import dbus
 from optparse import OptionParser
 import locale
+import datetime
+import re
 
 locale.setlocale(locale.LC_ALL, u'')
 
@@ -20,46 +24,170 @@
     'last_enabled': u'Last Enabled',
     'checker': u'Checker',
     }
-busname = 'org.mandos-system.Mandos'
-object_path = '/Mandos'
-interface = 'org.mandos_system.Mandos'
-version = "1.0.2"
 defaultkeywords = ('name', 'enabled', 'timeout', 'last_checked_ok',
                    'checker')
-
-parser = OptionParser(version = "%%prog %s" % version)
-parser.add_option("-a", "--all", action="store_true", default=False,
-                  help="Print all fields")
-options = parser.parse_args()[0]
-if options.all:
-    keywords = ('name', 'enabled', 'timeout', 'last_checked_ok',
-                'created', 'interval', 'host', 'fingerprint',
-                'checker_running', 'last_enabled', 'checker')
-else:
-    keywords = defaultkeywords
-
-
+domain = 'se.bsnet.fukt'
+busname = domain + '.Mandos'
+server_path = '/'
+server_interface = domain + '.Mandos'
+client_interface = domain + '.Mandos.Client'
+version = "1.0.8"
 bus = dbus.SystemBus()
-mandos_dbus_objc = bus.get_object(busname, object_path)
+mandos_dbus_objc = bus.get_object(busname, server_path)
 mandos_serv = dbus.Interface(mandos_dbus_objc,
-                             dbus_interface = interface)
+                             dbus_interface = server_interface)
 mandos_clients = mandos_serv.GetAllClientsWithProperties()
 
-def valuetostring(x):
-    if type(x) is dbus.Boolean:
-        return u"Yes" if x else u"No"
+def datetime_to_milliseconds(dt):
+    "Return the 'timeout' attribute in milliseconds"
+    return ((dt.days * 24 * 60 * 60 * 1000)
+            + (dt.seconds * 1000)
+            + (dt.microseconds // 1000))
+
+def milliseconds_to_string(ms):
+    td = datetime.timedelta(0, 0, 0, ms)
+    return "%s%02d:%02d:%02d" % (("%dT" % td.days) if td.days else "", # days
+                           td.seconds // 3600,        # hours
+                           (td.seconds % 3600) // 60, # minutes
+                           (td.seconds % 60))         # seconds
+
+
+def string_to_delta(interval):
+    """Parse a string and return a datetime.timedelta
+
+    >>> string_to_delta('7d')
+    datetime.timedelta(7)
+    >>> string_to_delta('60s')
+    datetime.timedelta(0, 60)
+    >>> string_to_delta('60m')
+    datetime.timedelta(0, 3600)
+    >>> string_to_delta('24h')
+    datetime.timedelta(1)
+    >>> string_to_delta(u'1w')
+    datetime.timedelta(7)
+    >>> string_to_delta('5m 30s')
+    datetime.timedelta(0, 330)
+    """
+    timevalue = datetime.timedelta(0)
+    regexp = re.compile("\d+[dsmhw]")
+    
+    for s in regexp.findall(interval):
+        try:
+            suffix = unicode(s[-1])
+            value = int(s[:-1])
+            if suffix == u"d":
+                delta = datetime.timedelta(value)
+            elif suffix == u"s":
+                delta = datetime.timedelta(0, value)
+            elif suffix == u"m":
+                delta = datetime.timedelta(0, 0, 0, 0, value)
+            elif suffix == u"h":
+                delta = datetime.timedelta(0, 0, 0, 0, 0, value)
+            elif suffix == u"w":
+                delta = datetime.timedelta(0, 0, 0, 0, 0, 0, value)
+            else:
+                raise ValueError
+        except (ValueError, IndexError):
+            raise ValueError
+        timevalue += delta
+    return timevalue
+
+def print_clients(clients):
+    def valuetostring(value, keyword):
+        if type(value) is dbus.Boolean:
+            return u"Yes" if value else u"No"
+        if keyword in ("timeout", "interval"):
+            return milliseconds_to_string(value)
+        return unicode(value)
+    
+    format_string = u' '.join(u'%%-%ds' %
+                              max(len(tablewords[key]),
+                                  max(len(valuetostring(client[key], key))
+                                      for client in
+                                      clients))
+                              for key in keywords)
+    print format_string % tuple(tablewords[key] for key in keywords) 
+    for client in clients:
+        print format_string % tuple(valuetostring(client[key], key)
+                                    for key in keywords)
+
+parser = OptionParser(version = "%%prog %s" % version)
+parser.add_option("-a", "--all", action="store_true",
+                  help="Print all fields")
+parser.add_option("-e", "--enable", action="store_true",
+                  help="Enable client")
+parser.add_option("-d", "--disable", action="store_true",
+                  help="disable client")
+parser.add_option("-b", "--bump-timeout", action="store_true",
+                  help="Bump timeout for client")
+parser.add_option("--start-checker", action="store_true",
+                  help="Start checker for client")
+parser.add_option("--stop-checker", action="store_true",
+                  help="Stop checker for client")
+parser.add_option("-V", "--is-valid", action="store_true",
+                  help="Check if client is still valid")
+parser.add_option("-r", "--remove", action="store_true",
+                  help="Remove client")
+parser.add_option("-c", "--checker", type="string",
+                  help="Set checker command for client")
+parser.add_option("-t", "--timeout", type="string",
+                  help="Set timeout for client")
+parser.add_option("-i", "--interval", type="string",
+                  help="Set checker interval for client")
+parser.add_option("-H", "--host", type="string",
+                  help="Set host for client")
+parser.add_option("-s", "--secret", type="string",
+                  help="Set password blob (file) for client")
+options, client_names = parser.parse_args()
+
+# Compile list of clients to process
+clients=[]
+for name in client_names:
+    for path, client in mandos_clients.iteritems():
+        if client['name'] == name:
+            client_objc = bus.get_object(busname, path)
+            clients.append(dbus.Interface(client_objc,
+                                          dbus_interface
+                                          = client_interface))
+            break
     else:
-        return unicode(x)
-
-format_string = u' '.join(u'%%-%ds'
-                         % max(len(tablewords[key]),
-                               max(len(valuetostring(client[key]))
-                                   for client
-                                   in mandos_clients.itervalues()))
-                         for key in keywords)
-print format_string % tuple(tablewords[key] for key in keywords) 
-for client in mandos_clients.itervalues():
-    print format_string % tuple(valuetostring(client[key])
-                                for key in keywords)
-
-
+        print >> sys.stderr, "Client not found on server: %r" % name
+        sys.exit(1)
+
+if not clients and mandos_clients.values():
+    keywords = defaultkeywords
+    if options.all:
+        keywords = ('name', 'enabled', 'timeout', 'last_checked_ok',
+                    'created', 'interval', 'host', 'fingerprint',
+                    'checker_running', 'last_enabled', 'checker')
+    print_clients(mandos_clients.values())
+
+# Process each client in the list by all selected options
+for client in clients:
+    if options.remove:
+        mandos_serv.RemoveClient(client.__dbus_object_path__)
+    if options.enable:
+        client.Enable()
+    if options.disable:
+        client.Disable()
+    if options.bump_timeout:
+        client.BumpTimeout()
+    if options.start_checker:
+        client.StartChecker()
+    if options.stop_checker:
+        client.StopChecker()
+    if options.is_valid:
+        sys.exit(0 if client.IsStillValid() else 1)
+    if options.checker:
+        client.SetChecker(options.checker)
+    if options.host:
+        client.SetHost(options.host)
+    if options.interval:
+        client.SetInterval(datetime_to_milliseconds
+                           (string_to_delta(options.interval)))
+    if options.timeout:
+        client.SetTimeout(datetime_to_milliseconds
+                          (string_to_delta(options.timeout)))
+    if options.secret:
+        client.SetSecret(dbus.ByteArray(open(options.secret, 'rb').read()))
+    

=== modified file 'mandos-keygen'
--- mandos-keygen	2009-01-06 02:42:53 +0000
+++ mandos-keygen	2009-02-25 01:31:13 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@fukt.bsnet.se>.
 # 
 
-VERSION="1.0.3"
+VERSION="1.0.8"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=DSA
@@ -147,7 +147,7 @@
 	echo "Invalid key length" >&2
 	exit 1
     fi
-
+    
     if [ -z "$KEYEXPIRE" ]; then
 	echo "Empty key expiration" >&2
 	exit 1
@@ -172,7 +172,7 @@
     if [ -n "$KEYEMAIL" ]; then
 	KEYEMAILLINE="Name-Email: $KEYEMAIL"
     fi
-
+    
     # Create temporary gpg batch file
     BATCHFILE="`mktemp -t mandos-keygen-batch.XXXXXXXXXX`"
 fi
@@ -284,7 +284,7 @@
 	stty echo
 	if [ "$first" != "$second" ]; then
 	    echo -e "Passphrase mismatch" >&2
-	    false
+	    touch "$RINGDIR"/mismatch
 	else
 	    echo -n "$first"
 	fi
@@ -292,9 +292,9 @@
 	--homedir "$RINGDIR" --trust-model always --armor --encrypt \
 	--sign --recipient "$FINGERPRINT" --comment "$FILECOMMENT" \
 	> "$SECFILE"
-    status="${PIPESTATUS[0]}"
-    if [ "$status" -ne 0 ]; then
-	exit "$status"
+    if [ -e "$RINGDIR"/mismatch ]; then
+	rm --force "$RINGDIR"/mismatch
+	exit 1
     fi
     
     cat <<-EOF

=== modified file 'mandos-options.xml'
--- mandos-options.xml	2008-12-29 02:44:54 +0000
+++ mandos-options.xml	2009-02-13 05:38:21 +0000
@@ -26,10 +26,12 @@
     specified IPv6 address.  If a link-local address is specified, an
     interface should be set, since a link-local address is only valid
     on a single interface.  By default, the server will listen to all
-    available addresses.  If set, this must be an IPv6 address; an
-    IPv4 address can only be specified using IPv4-mapped IPv6 address
-    syntax: <quote><systemitem class="ipaddress"
-    >::FFFF:192.0.2.3</systemitem ></quote>.
+    available addresses.  If set, this must normally be an IPv6
+    address; an IPv4 address can only be specified using IPv4-mapped
+    IPv6 address syntax: <quote><systemitem class="ipaddress"
+    >::FFFF:192.0.2.3</systemitem ></quote>.  (Only if IPv6 usage is
+    <emphasis>disabled</emphasis> (see below) must this be an IPv4
+    address.)
   </para>
   
   <para id="port">
@@ -65,11 +67,23 @@
     rename itself to <quote><literal>Mandos #2</literal></quote>, and
     so on; therefore, this option is not needed in that case.
   </para>
-
+  
   <para id="dbus">
     This option controls whether the server will provide a D-Bus
     system bus interface.  The default is to provide such an
     interface.
   </para>
   
+  <para id="ipv6">
+    This option controls whether the server will use IPv6 sockets and
+    addresses.  The default is to use IPv6.  This option should
+    <emphasis>never</emphasis> normally be turned off, <emphasis>even in
+    IPv4-only environments</emphasis>.  This is because <citerefentry>
+    <refentrytitle>mandos-client</refentrytitle>
+    <manvolnum>8mandos</manvolnum></citerefentry> will normally use
+    IPv6 link-local addresses, and will not be able to find or connect
+    to the server if this option is turned off.  <emphasis>Only
+    advanced users should consider changing this option</emphasis>.
+  </para>
+  
 </section>

=== modified file 'mandos.conf'
--- mandos.conf	2008-12-29 02:44:54 +0000
+++ mandos.conf	2009-02-13 05:38:21 +0000
@@ -39,3 +39,6 @@
 
 # Whether to provide a D-Bus system bus interface or not
 ;use_dbus = True
+
+# Whether to use IPv6.  (Changing this is NOT recommended.)
+;use_ipv6 = True

=== modified file 'mandos.conf.xml'
--- mandos.conf.xml	2009-01-04 21:54:55 +0000
+++ mandos.conf.xml	2009-02-25 01:14:29 +0000
@@ -3,7 +3,7 @@
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY CONFNAME "mandos.conf">
 <!ENTITY CONFPATH "<filename>/etc/mandos/mandos.conf</filename>">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2009-02-25">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -142,6 +142,17 @@
 	</listitem>
       </varlistentry>
       
+      <varlistentry>
+	<term><option>use_ipv6<literal> = </literal>{ <literal
+	  >1</literal> | <literal>yes</literal> | <literal
+	  >true</literal> | <literal>on</literal> | <literal
+	  >0</literal> | <literal>no</literal> | <literal
+	  >false</literal> | <literal>off</literal> }</option></term>
+	<listitem>
+	  <xi:include href="mandos-options.xml" xpointer="ipv6"/>
+	</listitem>
+      </varlistentry>
+      
     </variablelist>
   </refsect1>
   
@@ -179,12 +190,13 @@
 [DEFAULT]
 # A configuration example
 interface = eth0
-address = 2001:db8:f983:bd0b:30de:ae4a:71f2:f672
+address = fe80::aede:48ff:fe71:f6f2
 port = 1025
 debug = true
 priority = SECURE256:!CTYPE-X.509:+CTYPE-OPENPGP
 servicename = Daena
 use_dbus = False
+use_ipv6 = True
       </programlisting>
     </informalexample>
   </refsect1>
@@ -225,7 +237,7 @@
 	      <para>
 		The clients use IPv6 link-local addresses, which are
 		immediately usable since a link-local addresses is
-		automatically assigned to a network interfaces when it
+		automatically assigned to a network interface when it
 		is brought up.
 	      </para>
 	    </listitem>

=== modified file 'mandos.lsm'
--- mandos.lsm	2009-01-06 02:42:53 +0000
+++ mandos.lsm	2009-02-25 01:31:13 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.0.3
-Entered-date:	2009-01-06
+Version:	1.0.8
+Entered-date:	2009-02-25
 Description:	The Mandos system allows computers to have encrypted
 root file systems and at the same time be capable of remote and/or
 unattended reboots.
@@ -12,10 +12,10 @@
 Maintained-by:	teddy@fukt.bsnet.se (Teddy Hogeborn),
 		belorn@fukt.bsnet.se (Björn Påhlsson)
 Primary-site: http://www.fukt.bsnet.se/mandos
-	      92K mandos_1.0.3.orig.tar.gz
+	      98K mandos_1.0.8.orig.tar.gz
 Alternate-site: ftp://ftp.fukt.bsnet.se/pub/mandos
-		92K mandos_1.0.3.orig.tar.gz
-Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.4, and
+		98K mandos_1.0.8.orig.tar.gz
+Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.5, and
 various other libraries.  While made for Debian GNU/Linux, it is
 probably portable to other distributions, but not other Unixes.
 Copying-policy: GNU General Public License version 3.0 or later

=== modified file 'mandos.xml'
--- mandos.xml	2009-01-04 21:54:55 +0000
+++ mandos.xml	2009-02-25 01:21:37 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 "http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2009-02-24">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -86,7 +86,7 @@
       <sbr/>
       <arg><option>--debug</option></arg>
       <sbr/>
-      <arg><option>--no-dbus</option></arg>
+      <arg><option>--no-ipv6</option></arg>
     </cmdsynopsis>
     <cmdsynopsis>
       <command>&COMMANDNAME;</command>
@@ -233,12 +233,9 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>--no-dbus</option></term>
+	<term><option>--no-ipv6</option></term>
 	<listitem>
-	  <xi:include href="mandos-options.xml" xpointer="dbus"/>
-	  <para>
-	    See also <xref linkend="dbus_interface"/>.
-	  </para>
+	  <xi:include href="mandos-options.xml" xpointer="ipv6"/>
 	</listitem>
       </varlistentry>
     </variablelist>
@@ -336,16 +333,6 @@
     </para>
   </refsect1>
   
-  <refsect1 id="dbus_interface">
-    <title>D-BUS INTERFACE</title>
-    <para>
-      The server will by default provide a D-Bus system bus interface.
-      This interface will only be accessible by the root user or a
-      Mandos-specific user, if such a user exists.
-      <!-- XXX -->
-    </para>
-  </refsect1>
-
   <refsect1 id="exit_status">
     <title>EXIT STATUS</title>
     <para>
@@ -458,7 +445,7 @@
       Debug mode is conflated with running in the foreground.
     </para>
     <para>
-      The console log messages does not show a time stamp.
+      The console log messages do not show a time stamp.
     </para>
     <para>
       This server does not check the expire time of clients’ OpenPGP

=== modified file 'plugin-runner.c'
--- plugin-runner.c	2009-01-06 22:49:50 +0000
+++ plugin-runner.c	2009-02-12 19:08:35 +0000
@@ -62,8 +62,10 @@
 #include <signal.h> 		/* struct sigaction, sigemptyset(),
 				   sigaddset(), sigaction(),
 				   sigprocmask(), SIG_BLOCK, SIGCHLD,
-				   SIG_UNBLOCK, kill() */
+				   SIG_UNBLOCK, kill(), sig_atomic_t
+				*/
 #include <errno.h>		/* errno, EBADF */
+#include <inttypes.h>		/* intmax_t, PRIdMAX, strtoimax() */
 
 #define BUFFER_SIZE 256
 
@@ -80,7 +82,7 @@
   char **environ;
   int envc;
   bool disabled;
-
+  
   /* Variables used for running processes*/
   pid_t pid;
   int fd;
@@ -88,8 +90,8 @@
   size_t buffer_size;
   size_t buffer_length;
   bool eof;
-  volatile bool completed;
-  volatile int status;
+  volatile sig_atomic_t completed;
+  int status;
   struct plugin *next;
 } plugin;
 
@@ -99,32 +101,33 @@
    or if none is found, creates a new one */
 static plugin *getplugin(char *name){
   /* Check for exiting plugin with that name */
-  for (plugin *p = plugin_list; p != NULL; p = p->next){
-    if ((p->name == name)
-	or (p->name and name and (strcmp(p->name, name) == 0))){
+  for(plugin *p = plugin_list; p != NULL; p = p->next){
+    if((p->name == name)
+       or (p->name and name and (strcmp(p->name, name) == 0))){
       return p;
     }
   }
   /* Create a new plugin */
   plugin *new_plugin = malloc(sizeof(plugin));
-  if (new_plugin == NULL){
+  if(new_plugin == NULL){
     return NULL;
   }
   char *copy_name = NULL;
   if(name != NULL){
     copy_name = strdup(name);
     if(copy_name == NULL){
+      free(new_plugin);
       return NULL;
     }
   }
   
-  *new_plugin = (plugin) { .name = copy_name,
-			   .argc = 1,
-			   .disabled = false,
-			   .next = plugin_list };
+  *new_plugin = (plugin){ .name = copy_name,
+			  .argc = 1,
+			  .disabled = false,
+			  .next = plugin_list };
   
   new_plugin->argv = malloc(sizeof(char *) * 2);
-  if (new_plugin->argv == NULL){
+  if(new_plugin->argv == NULL){
     free(copy_name);
     free(new_plugin);
     return NULL;
@@ -221,6 +224,7 @@
 /* Mark processes as completed when they exit, and save their exit
    status. */
 static void handle_sigchld(__attribute__((unused)) int sig){
+  int old_errno = errno;
   while(true){
     plugin *proc = plugin_list;
     int status;
@@ -230,11 +234,11 @@
       break;
     }
     if(pid == -1){
-      if (errno != ECHILD){
-	perror("waitpid");
+      if(errno == ECHILD){
+	/* No child processes */
+	break;
       }
-      /* No child processes */
-      break;
+      perror("waitpid");
     }
     
     /* A child exited, find it in process_list */
@@ -246,8 +250,9 @@
       continue;
     }
     proc->status = status;
-    proc->completed = true;
+    proc->completed = 1;
   }
+  errno = old_errno;
 }
 
 /* Prints out a password to stdout */
@@ -275,7 +280,7 @@
   }
   free(plugin_node->environ);
   free(plugin_node->buffer);
-
+  
   /* Removes the plugin from the singly-linked list */
   if(plugin_node == plugin_list){
     /* First one - simple */
@@ -310,6 +315,7 @@
   fd_set rfds_all;
   int ret, maxfd = 0;
   ssize_t sret;
+  intmax_t tmpmax;
   uid_t uid = 65534;
   gid_t gid = 65534;
   bool debug = false;
@@ -372,17 +378,18 @@
     { .name = NULL }
   };
   
-  error_t parse_opt (int key, char *arg, __attribute__((unused))
-		     struct argp_state *state) {
-    switch (key) {
+  error_t parse_opt(int key, char *arg, __attribute__((unused))
+		    struct argp_state *state){
+    char *tmp;
+    switch(key){
     case 'g': 			/* --global-options */
-      if (arg != NULL){
-	char *p;
-	while((p = strsep(&arg, ",")) != NULL){
-	  if(p[0] == '\0'){
+      if(arg != NULL){
+	char *plugin_option;
+	while((plugin_option = strsep(&arg, ",")) != NULL){
+	  if(plugin_option[0] == '\0'){
 	    continue;
 	  }
-	  if(not add_argument(getplugin(NULL), p)){
+	  if(not add_argument(getplugin(NULL), plugin_option)){
 	    perror("add_argument");
 	    return ARGP_ERR_UNKNOWN;
 	  }
@@ -398,21 +405,14 @@
       }
       break;
     case 'o':			/* --options-for */
-      if (arg != NULL){
-	char *p_name = strsep(&arg, ":");
-	if(p_name[0] == '\0' or arg == NULL){
-	  break;
-	}
-	char *opt = strsep(&arg, ":");
-	if(opt[0] == '\0' or opt == NULL){
-	  break;
-	}
-	char *p;
-	while((p = strsep(&opt, ",")) != NULL){
-	  if(p[0] == '\0'){
-	    continue;
-	  }
-	  if(not add_argument(getplugin(p_name), p)){
+      if(arg != NULL){
+	char *plugin_name = strsep(&arg, ":");
+	if(plugin_name[0] == '\0'){
+	  break;
+	}
+	char *plugin_option;
+	while((plugin_option = strsep(&arg, ",")) != NULL){
+	  if(not add_argument(getplugin(plugin_name), plugin_option)){
 	    perror("add_argument");
 	    return ARGP_ERR_UNKNOWN;
 	  }
@@ -435,7 +435,7 @@
       }
       break;
     case 'd':			/* --disable */
-      if (arg != NULL){
+      if(arg != NULL){
 	plugin *p = getplugin(arg);
 	if(p == NULL){
 	  return ARGP_ERR_UNKNOWN;
@@ -444,7 +444,7 @@
       }
       break;
     case 'e':			/* --enable */
-      if (arg != NULL){
+      if(arg != NULL){
 	plugin *p = getplugin(arg);
 	if(p == NULL){
 	  return ARGP_ERR_UNKNOWN;
@@ -463,14 +463,34 @@
       /* This is already done by parse_opt_config_file() */
       break;
     case 130:			/* --userid */
-      uid = (uid_t)strtol(arg, NULL, 10);
+      errno = 0;
+      tmpmax = strtoimax(arg, &tmp, 10);
+      if(errno != 0 or tmp == arg or *tmp != '\0'
+	 or tmpmax != (uid_t)tmpmax){
+	fprintf(stderr, "Bad user ID number: \"%s\", using %"
+		PRIdMAX "\n", arg, (intmax_t)uid);
+      } else {
+	uid = (uid_t)tmpmax;
+      }
       break;
     case 131:			/* --groupid */
-      gid = (gid_t)strtol(arg, NULL, 10);
+      errno = 0;
+      tmpmax = strtoimax(arg, &tmp, 10);
+      if(errno != 0 or tmp == arg or *tmp != '\0'
+	 or tmpmax != (gid_t)tmpmax){
+	fprintf(stderr, "Bad group ID number: \"%s\", using %"
+		PRIdMAX "\n", arg, (intmax_t)gid);
+      } else {
+	gid = (gid_t)tmpmax;
+      }
       break;
     case 132:			/* --debug */
       debug = true;
       break;
+/*
+ * When adding more options before this line, remember to also add a
+ * "case" to the "parse_opt_config_file" function below.
+ */
     case ARGP_KEY_ARG:
       /* Cryptsetup always passes an argument, which is an empty
 	 string if "none" was specified in /etc/crypttab.  So if
@@ -489,10 +509,10 @@
   
   /* This option parser is the same as parse_opt() above, except it
      ignores everything but the --config-file option. */
-  error_t parse_opt_config_file (int key, char *arg,
-				 __attribute__((unused))
-				 struct argp_state *state) {
-    switch (key) {
+  error_t parse_opt_config_file(int key, char *arg,
+				__attribute__((unused))
+				struct argp_state *state){
+    switch(key){
     case 'g': 			/* --global-options */
     case 'G':			/* --global-env */
     case 'o':			/* --options-for */
@@ -525,10 +545,10 @@
 		       .args_doc = "",
 		       .doc = "Mandos plugin runner -- Run plugins" };
   
-  /* Parse using the parse_opt_config_file in order to get the custom
+  /* Parse using parse_opt_config_file() in order to get the custom
      config file location, if any. */
-  ret = argp_parse (&argp, argc, argv, ARGP_IN_ORDER, 0, NULL);
-  if (ret == ARGP_ERR_UNKNOWN){
+  ret = argp_parse(&argp, argc, argv, ARGP_IN_ORDER, 0, NULL);
+  if(ret == ARGP_ERR_UNKNOWN){
     fprintf(stderr, "Unknown error while parsing arguments\n");
     exitstatus = EXIT_FAILURE;
     goto fallback;
@@ -538,7 +558,7 @@
   argp.parser = parse_opt;
   
   /* Open the configfile if available */
-  if (argfile == NULL){
+  if(argfile == NULL){
     conffp = fopen(AFILE, "r");
   } else {
     conffp = fopen(argfile, "r");
@@ -549,7 +569,7 @@
     size_t size = 0;
     const char whitespace_delims[] = " \r\t\f\v\n";
     const char comment_delim[] = "#";
-
+    
     custom_argc = 1;
     custom_argv = malloc(sizeof(char*) * 2);
     if(custom_argv == NULL){
@@ -559,7 +579,7 @@
     }
     custom_argv[0] = argv[0];
     custom_argv[1] = NULL;
-
+    
     /* for each line in the config file, strip whitespace and ignore
        commented text */
     while(true){
@@ -567,7 +587,7 @@
       if(sret == -1){
 	break;
       }
-
+      
       line = org_line;
       arg = strsep(&line, comment_delim);
       while((p = strsep(&arg, whitespace_delims)) != NULL){
@@ -599,7 +619,7 @@
   } else {
     /* Check for harmful errors and go to fallback. Other errors might
        not affect opening plugins */
-    if (errno == EMFILE or errno == ENFILE or errno == ENOMEM){
+    if(errno == EMFILE or errno == ENFILE or errno == ENOMEM){
       perror("fopen");
       exitstatus = EXIT_FAILURE;
       goto fallback;
@@ -608,9 +628,9 @@
   /* If there was any arguments from configuration file,
      pass them to parser as command arguments */
   if(custom_argv != NULL){
-    ret = argp_parse (&argp, custom_argc, custom_argv, ARGP_IN_ORDER,
-		      0, NULL);
-    if (ret == ARGP_ERR_UNKNOWN){
+    ret = argp_parse(&argp, custom_argc, custom_argv, ARGP_IN_ORDER,
+		     0, NULL);
+    if(ret == ARGP_ERR_UNKNOWN){
       fprintf(stderr, "Unknown error while parsing arguments\n");
       exitstatus = EXIT_FAILURE;
       goto fallback;
@@ -619,8 +639,8 @@
   
   /* Parse actual command line arguments, to let them override the
      config file */
-  ret = argp_parse (&argp, argc, argv, ARGP_IN_ORDER, 0, NULL);
-  if (ret == ARGP_ERR_UNKNOWN){
+  ret = argp_parse(&argp, argc, argv, ARGP_IN_ORDER, 0, NULL);
+  if(ret == ARGP_ERR_UNKNOWN){
     fprintf(stderr, "Unknown error while parsing arguments\n");
     exitstatus = EXIT_FAILURE;
     goto fallback;
@@ -633,7 +653,7 @@
       for(char **a = p->argv; *a != NULL; a++){
 	fprintf(stderr, "\tArg: %s\n", *a);
       }
-      fprintf(stderr, "...and %u environment variables\n", p->envc);
+      fprintf(stderr, "...and %d environment variables\n", p->envc);
       for(char **a = p->environ; *a != NULL; a++){
 	fprintf(stderr, "\t%s\n", *a);
       }
@@ -641,16 +661,16 @@
   }
   
   /* Strip permissions down to nobody */
+  setgid(gid);
+  if(ret == -1){
+    perror("setgid");
+  }
   ret = setuid(uid);
-  if (ret == -1){
+  if(ret == -1){
     perror("setuid");
-  }  
-  setgid(gid);
-  if (ret == -1){
-    perror("setgid");
   }
   
-  if (plugindir == NULL){
+  if(plugindir == NULL){
     dir = opendir(PDIR);
   } else {
     dir = opendir(plugindir);
@@ -683,7 +703,7 @@
     
     /* All directory entries have been processed */
     if(dirst == NULL){
-      if (errno == EBADF){
+      if(errno == EBADF){
 	perror("readdir");
 	exitstatus = EXIT_FAILURE;
 	goto fallback;
@@ -736,7 +756,7 @@
 	continue;
       }
     }
-
+    
     char *filename;
     if(plugindir == NULL){
       ret = asprintf(&filename, PDIR "/%s", dirst->d_name);
@@ -749,14 +769,14 @@
     }
     
     ret = stat(filename, &st);
-    if (ret == -1){
+    if(ret == -1){
       perror("stat");
       free(filename);
       continue;
     }
-
+    
     /* Ignore non-executable files */
-    if (not S_ISREG(st.st_mode)	or (access(filename, X_OK) != 0)){
+    if(not S_ISREG(st.st_mode) or (access(filename, X_OK) != 0)){
       if(debug){
 	fprintf(stderr, "Ignoring plugin dir entry \"%s\""
 		" with bad type or mode\n", filename);
@@ -809,7 +829,7 @@
     
     int pipefd[2];
     ret = pipe(pipefd);
-    if (ret == -1){
+    if(ret == -1){
       perror("pipe");
       exitstatus = EXIT_FAILURE;
       goto fallback;
@@ -828,7 +848,7 @@
       goto fallback;
     }
     /* Block SIGCHLD until process is safely in process list */
-    ret = sigprocmask (SIG_BLOCK, &sigchld_action.sa_mask, NULL);
+    ret = sigprocmask(SIG_BLOCK, &sigchld_action.sa_mask, NULL);
     if(ret < 0){
       perror("sigprocmask");
       exitstatus = EXIT_FAILURE;
@@ -882,9 +902,9 @@
     close(pipefd[1]);		/* Close unused write end of pipe */
     free(filename);
     plugin *new_plugin = getplugin(dirst->d_name);
-    if (new_plugin == NULL){
+    if(new_plugin == NULL){
       perror("getplugin");
-      ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
+      ret = sigprocmask(SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
       if(ret < 0){
         perror("sigprocmask");
       }
@@ -897,7 +917,7 @@
     
     /* Unblock SIGCHLD so signal handler can be run if this process
        has already completed */
-    ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
+    ret = sigprocmask(SIG_UNBLOCK, &sigchld_action.sa_mask, NULL);
     if(ret < 0){
       perror("sigprocmask");
       exitstatus = EXIT_FAILURE;
@@ -906,13 +926,14 @@
     
     FD_SET(new_plugin->fd, &rfds_all);
     
-    if (maxfd < new_plugin->fd){
+    if(maxfd < new_plugin->fd){
       maxfd = new_plugin->fd;
     }
   }
   
   closedir(dir);
   dir = NULL;
+  free_plugin(getplugin(NULL));
   
   for(plugin *p = plugin_list; p != NULL; p = p->next){
     if(p->pid != 0){
@@ -929,7 +950,7 @@
   while(plugin_list){
     fd_set rfds = rfds_all;
     int select_ret = select(maxfd+1, &rfds, NULL, NULL, NULL);
-    if (select_ret == -1){
+    if(select_ret == -1){
       perror("select");
       exitstatus = EXIT_FAILURE;
       goto fallback;
@@ -938,30 +959,32 @@
        from one of them */
     for(plugin *proc = plugin_list; proc != NULL;){
       /* Is this process completely done? */
-      if(proc->eof and proc->completed){
+      if(proc->completed and proc->eof){
 	/* Only accept the plugin output if it exited cleanly */
 	if(not WIFEXITED(proc->status)
 	   or WEXITSTATUS(proc->status) != 0){
 	  /* Bad exit by plugin */
-
+	  
 	  if(debug){
 	    if(WIFEXITED(proc->status)){
-	      fprintf(stderr, "Plugin %u exited with status %d\n",
-		      (unsigned int) (proc->pid),
+	      fprintf(stderr, "Plugin %s [%" PRIdMAX "] exited with"
+		      " status %d\n", proc->name,
+		      (intmax_t) (proc->pid),
 		      WEXITSTATUS(proc->status));
-	    } else if(WIFSIGNALED(proc->status)) {
-	      fprintf(stderr, "Plugin %u killed by signal %d\n",
-		      (unsigned int) (proc->pid),
+	    } else if(WIFSIGNALED(proc->status)){
+	      fprintf(stderr, "Plugin %s [%" PRIdMAX "] killed by"
+		      " signal %d\n", proc->name,
+		      (intmax_t) (proc->pid),
 		      WTERMSIG(proc->status));
 	    } else if(WCOREDUMP(proc->status)){
-	      fprintf(stderr, "Plugin %d dumped core\n",
-		      (unsigned int) (proc->pid));
+	      fprintf(stderr, "Plugin %s [%" PRIdMAX "] dumped"
+		      " core\n", proc->name, (intmax_t) (proc->pid));
 	    }
 	  }
 	  
 	  /* Remove the plugin */
 	  FD_CLR(proc->fd, &rfds_all);
-
+	  
 	  /* Block signal while modifying process_list */
 	  ret = sigprocmask(SIG_BLOCK, &sigchld_action.sa_mask, NULL);
 	  if(ret < 0){
@@ -975,8 +998,8 @@
 	  proc = next_plugin;
 	  
 	  /* We are done modifying process list, so unblock signal */
-	  ret = sigprocmask (SIG_UNBLOCK, &sigchld_action.sa_mask,
-			     NULL);
+	  ret = sigprocmask(SIG_UNBLOCK, &sigchld_action.sa_mask,
+			    NULL);
 	  if(ret < 0){
 	    perror("sigprocmask");
 	    exitstatus = EXIT_FAILURE;
@@ -1011,7 +1034,7 @@
       if(proc->buffer_length + BUFFER_SIZE > proc->buffer_size){
 	proc->buffer = realloc(proc->buffer, proc->buffer_size
 			       + (size_t) BUFFER_SIZE);
-	if (proc->buffer == NULL){
+	if(proc->buffer == NULL){
 	  perror("malloc");
 	  exitstatus = EXIT_FAILURE;
 	  goto fallback;
@@ -1034,8 +1057,8 @@
       }
     }
   }
-
-
+  
+  
  fallback:
   
   if(plugin_list == NULL or exitstatus != EXIT_SUCCESS){

=== modified file 'plugin-runner.conf'
--- plugin-runner.conf	2008-10-05 17:38:31 +0000
+++ plugin-runner.conf	2009-02-09 02:01:13 +0000
@@ -4,8 +4,6 @@
 ##
 ## After editing this file, the initrd image file must be updated for
 ## the changes to take effect!
-## 
-## The default network interface for mandos-client(8mandos) is
-## "eth0".  Uncomment this line and change it if necessary.
-## 
-#--options-for=mandos-client:--interface=eth0
+
+## Example:
+#--options-for=mandos-client:--debug

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2009-01-04 21:54:55 +0000
+++ plugin-runner.xml	2009-01-18 06:41:57 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2009-01-17">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -579,7 +579,7 @@
       <para>
 
 <!-- do not wrap this line -->
-<userinput>&COMMANDNAME;  --config-file=/etc/mandos/plugin-runner.conf --plugin-dir /usr/lib/mandos/plugins.d --options-for=mandos-client:--pubkey=/etc/keys/mandos/pubkey.txt,--seckey=/etc/keys/mandos/seckey.txt</userinput>
+<userinput>cd /etc/keys/mandos; &COMMANDNAME;  --config-file=/etc/mandos/plugin-runner.conf --plugin-dir /usr/lib/mandos/plugins.d --options-for=mandos-client:--pubkey=pubkey.txt,--seckey=seckey.txt</userinput>
 
       </para>
     </informalexample>

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2009-01-04 21:54:55 +0000
+++ plugins.d/askpass-fifo.c	2009-01-10 06:00:50 +0000
@@ -1,6 +1,6 @@
 /*  -*- coding: utf-8 -*- */
 /*
- * Passprompt - Read a password from a FIFO and output it
+ * Askpass-FIFO - Read a password from a FIFO and output it
  * 
  * Copyright © 2008,2009 Teddy Hogeborn
  * Copyright © 2008,2009 Björn Påhlsson
@@ -43,14 +43,14 @@
   
   /* Create FIFO */
   const char passfifo[] = "/lib/cryptsetup/passfifo";
-  ret = TEMP_FAILURE_RETRY(mkfifo(passfifo, S_IRUSR | S_IWUSR));
+  ret = (int)TEMP_FAILURE_RETRY(mkfifo(passfifo, S_IRUSR | S_IWUSR));
   if(ret == -1 and errno != EEXIST){
     perror("mkfifo");
     return EXIT_FAILURE;
   }
   
   /* Open FIFO */
-  int fifo_fd = TEMP_FAILURE_RETRY(open(passfifo, O_RDONLY));
+  int fifo_fd = (int)TEMP_FAILURE_RETRY(open(passfifo, O_RDONLY));
   if(fifo_fd == -1){
     perror("open");
     return EXIT_FAILURE;

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2009-01-04 21:54:55 +0000
+++ plugins.d/mandos-client.c	2009-02-14 18:07:05 +0000
@@ -1,6 +1,6 @@
 /*  -*- coding: utf-8 -*- */
 /*
- * Mandos client - get and decrypt data from a Mandos server
+ * Mandos-client - get and decrypt data from a Mandos server
  *
  * This program is partly derived from an example program for an Avahi
  * service browser, downloaded from
@@ -30,48 +30,62 @@
  */
 
 /* Needed by GPGME, specifically gpgme_data_seek() */
+#ifndef _LARGEFILE_SOURCE
 #define _LARGEFILE_SOURCE
+#endif
+#ifndef _FILE_OFFSET_BITS
 #define _FILE_OFFSET_BITS 64
+#endif
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY(), asprintf() */
 
 #include <stdio.h>		/* fprintf(), stderr, fwrite(),
-				   stdout, ferror() */
+				   stdout, ferror(), remove() */
 #include <stdint.h> 		/* uint16_t, uint32_t */
 #include <stddef.h>		/* NULL, size_t, ssize_t */
 #include <stdlib.h> 		/* free(), EXIT_SUCCESS, EXIT_FAILURE,
-				   srand() */
-#include <stdbool.h>		/* bool, true */
+				   srand(), strtof() */
+#include <stdbool.h>		/* bool, false, true */
 #include <string.h>		/* memset(), strcmp(), strlen(),
 				   strerror(), asprintf(), strcpy() */
-#include <sys/ioctl.h>          /* ioctl */
+#include <sys/ioctl.h>		/* ioctl */
 #include <sys/types.h>		/* socket(), inet_pton(), sockaddr,
 				   sockaddr_in6, PF_INET6,
-				   SOCK_STREAM, INET6_ADDRSTRLEN,
-				   uid_t, gid_t, open(), opendir(), DIR */
+				   SOCK_STREAM, uid_t, gid_t, open(),
+				   opendir(), DIR */
 #include <sys/stat.h>		/* open() */
 #include <sys/socket.h>		/* socket(), struct sockaddr_in6,
-				   struct in6_addr, inet_pton(),
-				   connect() */
+				   inet_pton(), connect() */
 #include <fcntl.h>		/* open() */
-#include <dirent.h>		/* opendir(), struct dirent, readdir() */
-#include <inttypes.h>		/* PRIu16 */
+#include <dirent.h>		/* opendir(), struct dirent, readdir()
+				 */
+#include <inttypes.h>		/* PRIu16, PRIdMAX, intmax_t,
+				   strtoimax() */
 #include <assert.h>		/* assert() */
 #include <errno.h>		/* perror(), errno */
-#include <time.h>		/* time() */
+#include <time.h>		/* nanosleep(), time() */
 #include <net/if.h>		/* ioctl, ifreq, SIOCGIFFLAGS, IFF_UP,
 				   SIOCSIFFLAGS, if_indextoname(),
 				   if_nametoindex(), IF_NAMESIZE */
-#include <netinet/in.h>
+#include <netinet/in.h>		/* IN6_IS_ADDR_LINKLOCAL,
+				   INET_ADDRSTRLEN, INET6_ADDRSTRLEN
+				*/
 #include <unistd.h>		/* close(), SEEK_SET, off_t, write(),
 				   getuid(), getgid(), setuid(),
 				   setgid() */
 #include <arpa/inet.h>		/* inet_pton(), htons */
-#include <iso646.h>		/* not, and */
+#include <iso646.h>		/* not, or, and */
 #include <argp.h>		/* struct argp_option, error_t, struct
 				   argp_state, struct argp,
 				   argp_parse(), ARGP_KEY_ARG,
 				   ARGP_KEY_END, ARGP_ERR_UNKNOWN */
+#include <signal.h>		/* sigemptyset(), sigaddset(),
+				   sigaction(), SIGTERM, sigaction,
+				   sig_atomic_t */
+
+#ifdef __linux__
+#include <sys/klog.h> 		/* klogctl() */
+#endif	/* __linux__ */
 
 /* Avahi */
 /* All Avahi types, constants and functions
@@ -90,7 +104,8 @@
 				   gnutls_*
 				   init_gnutls_session(),
 				   GNUTLS_* */
-#include <gnutls/openpgp.h>     /* gnutls_certificate_set_openpgp_key_file(),
+#include <gnutls/openpgp.h>
+			  /* gnutls_certificate_set_openpgp_key_file(),
 				   GNUTLS_OPENPGP_FMT_BASE64 */
 
 /* GPGME */
@@ -122,16 +137,21 @@
   gpgme_ctx_t ctx;
 } mandos_context;
 
+/* global context so signal handler can reach it*/
+mandos_context mc = { .simple_poll = NULL, .server = NULL,
+		      .dh_bits = 1024, .priority = "SECURE256"
+		      ":!CTYPE-X.509:+CTYPE-OPENPGP" };
+
 /*
- * Make room in "buffer" for at least BUFFER_SIZE additional bytes.
- * "buffer_capacity" is how much is currently allocated,
+ * Make additional room in "buffer" for at least BUFFER_SIZE more
+ * bytes. "buffer_capacity" is how much is currently allocated,
  * "buffer_length" is how much is already used.
  */
-size_t adjustbuffer(char **buffer, size_t buffer_length,
+size_t incbuffer(char **buffer, size_t buffer_length,
 		  size_t buffer_capacity){
-  if (buffer_length + BUFFER_SIZE > buffer_capacity){
+  if(buffer_length + BUFFER_SIZE > buffer_capacity){
     *buffer = realloc(*buffer, buffer_capacity + BUFFER_SIZE);
-    if (buffer == NULL){
+    if(buffer == NULL){
       return 0;
     }
     buffer_capacity += BUFFER_SIZE;
@@ -142,7 +162,7 @@
 /* 
  * Initialize GPGME.
  */
-static bool init_gpgme(mandos_context *mc, const char *seckey,
+static bool init_gpgme(const char *seckey,
 		       const char *pubkey, const char *tempdir){
   int ret;
   gpgme_error_t rc;
@@ -150,33 +170,33 @@
   
   
   /*
-   * Helper function to insert pub and seckey to the enigne keyring.
+   * Helper function to insert pub and seckey to the engine keyring.
    */
   bool import_key(const char *filename){
     int fd;
     gpgme_data_t pgp_data;
     
-    fd = TEMP_FAILURE_RETRY(open(filename, O_RDONLY));
+    fd = (int)TEMP_FAILURE_RETRY(open(filename, O_RDONLY));
     if(fd == -1){
       perror("open");
       return false;
     }
     
     rc = gpgme_data_new_from_fd(&pgp_data, fd);
-    if (rc != GPG_ERR_NO_ERROR){
+    if(rc != GPG_ERR_NO_ERROR){
       fprintf(stderr, "bad gpgme_data_new_from_fd: %s: %s\n",
 	      gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
     
-    rc = gpgme_op_import(mc->ctx, pgp_data);
-    if (rc != GPG_ERR_NO_ERROR){
+    rc = gpgme_op_import(mc.ctx, pgp_data);
+    if(rc != GPG_ERR_NO_ERROR){
       fprintf(stderr, "bad gpgme_op_import: %s: %s\n",
 	      gpgme_strsource(rc), gpgme_strerror(rc));
       return false;
     }
     
-    ret = TEMP_FAILURE_RETRY(close(fd));
+    ret = (int)TEMP_FAILURE_RETRY(close(fd));
     if(ret == -1){
       perror("close");
     }
@@ -184,22 +204,22 @@
     return true;
   }
   
-  if (debug){
-    fprintf(stderr, "Initialize gpgme\n");
+  if(debug){
+    fprintf(stderr, "Initializing GPGME\n");
   }
   
   /* Init GPGME */
   gpgme_check_version(NULL);
   rc = gpgme_engine_check_version(GPGME_PROTOCOL_OpenPGP);
-  if (rc != GPG_ERR_NO_ERROR){
+  if(rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_engine_check_version: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   
     /* Set GPGME home directory for the OpenPGP engine only */
-  rc = gpgme_get_engine_info (&engine_info);
-  if (rc != GPG_ERR_NO_ERROR){
+  rc = gpgme_get_engine_info(&engine_info);
+  if(rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_get_engine_info: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
@@ -218,14 +238,14 @@
   }
   
   /* Create new GPGME "context" */
-  rc = gpgme_new(&(mc->ctx));
-  if (rc != GPG_ERR_NO_ERROR){
+  rc = gpgme_new(&(mc.ctx));
+  if(rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_new: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return false;
   }
   
-  if (not import_key(pubkey) or not import_key(seckey)){
+  if(not import_key(pubkey) or not import_key(seckey)){
     return false;
   }
   
@@ -236,24 +256,23 @@
  * Decrypt OpenPGP data.
  * Returns -1 on error
  */
-static ssize_t pgp_packet_decrypt (const mandos_context *mc,
-				   const char *cryptotext,
-				   size_t crypto_size,
-				   char **plaintext){
+static ssize_t pgp_packet_decrypt(const char *cryptotext,
+				  size_t crypto_size,
+				  char **plaintext){
   gpgme_data_t dh_crypto, dh_plain;
   gpgme_error_t rc;
   ssize_t ret;
   size_t plaintext_capacity = 0;
   ssize_t plaintext_length = 0;
   
-  if (debug){
+  if(debug){
     fprintf(stderr, "Trying to decrypt OpenPGP data\n");
   }
   
   /* Create new GPGME data buffer from memory cryptotext */
   rc = gpgme_data_new_from_mem(&dh_crypto, cryptotext, crypto_size,
 			       0);
-  if (rc != GPG_ERR_NO_ERROR){
+  if(rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_data_new_from_mem: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return -1;
@@ -261,7 +280,7 @@
   
   /* Create new empty GPGME data buffer for the plaintext */
   rc = gpgme_data_new(&dh_plain);
-  if (rc != GPG_ERR_NO_ERROR){
+  if(rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_data_new: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     gpgme_data_release(dh_crypto);
@@ -270,15 +289,15 @@
   
   /* Decrypt data from the cryptotext data buffer to the plaintext
      data buffer */
-  rc = gpgme_op_decrypt(mc->ctx, dh_crypto, dh_plain);
-  if (rc != GPG_ERR_NO_ERROR){
+  rc = gpgme_op_decrypt(mc.ctx, dh_crypto, dh_plain);
+  if(rc != GPG_ERR_NO_ERROR){
     fprintf(stderr, "bad gpgme_op_decrypt: %s: %s\n",
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     plaintext_length = -1;
-    if (debug){
+    if(debug){
       gpgme_decrypt_result_t result;
-      result = gpgme_op_decrypt_result(mc->ctx);
-      if (result == NULL){
+      result = gpgme_op_decrypt_result(mc.ctx);
+      if(result == NULL){
 	fprintf(stderr, "gpgme_op_decrypt_result failed\n");
       } else {
 	fprintf(stderr, "Unsupported algorithm: %s\n",
@@ -311,7 +330,7 @@
   }
   
   /* Seek back to the beginning of the GPGME plaintext data buffer */
-  if (gpgme_data_seek(dh_plain, (off_t) 0, SEEK_SET) == -1){
+  if(gpgme_data_seek(dh_plain, (off_t)0, SEEK_SET) == -1){
     perror("gpgme_data_seek");
     plaintext_length = -1;
     goto decrypt_end;
@@ -319,11 +338,11 @@
   
   *plaintext = NULL;
   while(true){
-    plaintext_capacity = adjustbuffer(plaintext,
+    plaintext_capacity = incbuffer(plaintext,
 				      (size_t)plaintext_length,
 				      plaintext_capacity);
-    if (plaintext_capacity == 0){
-	perror("adjustbuffer");
+    if(plaintext_capacity == 0){
+	perror("incbuffer");
 	plaintext_length = -1;
 	goto decrypt_end;
     }
@@ -331,7 +350,7 @@
     ret = gpgme_data_read(dh_plain, *plaintext + plaintext_length,
 			  BUFFER_SIZE);
     /* Print the data, if any */
-    if (ret == 0){
+    if(ret == 0){
       /* EOF */
       break;
     }
@@ -361,9 +380,10 @@
   return plaintext_length;
 }
 
-static const char * safer_gnutls_strerror (int value) {
-  const char *ret = gnutls_strerror (value); /* Spurious warning */
-  if (ret == NULL)
+static const char * safer_gnutls_strerror(int value){
+  const char *ret = gnutls_strerror(value); /* Spurious warning from
+					       -Wunreachable-code */
+  if(ret == NULL)
     ret = "(unknown)";
   return ret;
 }
@@ -374,8 +394,7 @@
   fprintf(stderr, "GnuTLS: %s", string);
 }
 
-static int init_gnutls_global(mandos_context *mc,
-			      const char *pubkeyfilename,
+static int init_gnutls_global(const char *pubkeyfilename,
 			      const char *seckeyfilename){
   int ret;
   
@@ -384,13 +403,13 @@
   }
   
   ret = gnutls_global_init();
-  if (ret != GNUTLS_E_SUCCESS) {
-    fprintf (stderr, "GnuTLS global_init: %s\n",
-	     safer_gnutls_strerror(ret));
+  if(ret != GNUTLS_E_SUCCESS){
+    fprintf(stderr, "GnuTLS global_init: %s\n",
+	    safer_gnutls_strerror(ret));
     return -1;
   }
   
-  if (debug){
+  if(debug){
     /* "Use a log level over 10 to enable all debugging options."
      * - GnuTLS manual
      */
@@ -399,12 +418,14 @@
   }
   
   /* OpenPGP credentials */
-  gnutls_certificate_allocate_credentials(&mc->cred);
-  if (ret != GNUTLS_E_SUCCESS){
-    fprintf (stderr, "GnuTLS memory error: %s\n", /* Spurious
-						     warning */
-	     safer_gnutls_strerror(ret));
-    gnutls_global_deinit ();
+  gnutls_certificate_allocate_credentials(&mc.cred);
+  if(ret != GNUTLS_E_SUCCESS){
+    fprintf(stderr, "GnuTLS memory error: %s\n", /* Spurious warning
+						    from
+						    -Wunreachable-code
+						 */
+	    safer_gnutls_strerror(ret));
+    gnutls_global_deinit();
     return -1;
   }
   
@@ -415,9 +436,9 @@
   }
   
   ret = gnutls_certificate_set_openpgp_key_file
-    (mc->cred, pubkeyfilename, seckeyfilename,
+    (mc.cred, pubkeyfilename, seckeyfilename,
      GNUTLS_OPENPGP_FMT_BASE64);
-  if (ret != GNUTLS_E_SUCCESS) {
+  if(ret != GNUTLS_E_SUCCESS){
     fprintf(stderr,
 	    "Error[%d] while reading the OpenPGP key pair ('%s',"
 	    " '%s')\n", ret, pubkeyfilename, seckeyfilename);
@@ -427,67 +448,66 @@
   }
   
   /* GnuTLS server initialization */
-  ret = gnutls_dh_params_init(&mc->dh_params);
-  if (ret != GNUTLS_E_SUCCESS) {
-    fprintf (stderr, "Error in GnuTLS DH parameter initialization:"
-	     " %s\n", safer_gnutls_strerror(ret));
+  ret = gnutls_dh_params_init(&mc.dh_params);
+  if(ret != GNUTLS_E_SUCCESS){
+    fprintf(stderr, "Error in GnuTLS DH parameter initialization:"
+	    " %s\n", safer_gnutls_strerror(ret));
     goto globalfail;
   }
-  ret = gnutls_dh_params_generate2(mc->dh_params, mc->dh_bits);
-  if (ret != GNUTLS_E_SUCCESS) {
-    fprintf (stderr, "Error in GnuTLS prime generation: %s\n",
-	     safer_gnutls_strerror(ret));
+  ret = gnutls_dh_params_generate2(mc.dh_params, mc.dh_bits);
+  if(ret != GNUTLS_E_SUCCESS){
+    fprintf(stderr, "Error in GnuTLS prime generation: %s\n",
+	    safer_gnutls_strerror(ret));
     goto globalfail;
   }
   
-  gnutls_certificate_set_dh_params(mc->cred, mc->dh_params);
+  gnutls_certificate_set_dh_params(mc.cred, mc.dh_params);
   
   return 0;
   
  globalfail:
   
-  gnutls_certificate_free_credentials(mc->cred);
+  gnutls_certificate_free_credentials(mc.cred);
   gnutls_global_deinit();
-  gnutls_dh_params_deinit(mc->dh_params);
+  gnutls_dh_params_deinit(mc.dh_params);
   return -1;
 }
 
-static int init_gnutls_session(mandos_context *mc,
-			       gnutls_session_t *session){
+static int init_gnutls_session(gnutls_session_t *session){
   int ret;
   /* GnuTLS session creation */
   ret = gnutls_init(session, GNUTLS_SERVER);
-  if (ret != GNUTLS_E_SUCCESS){
+  if(ret != GNUTLS_E_SUCCESS){
     fprintf(stderr, "Error in GnuTLS session initialization: %s\n",
 	    safer_gnutls_strerror(ret));
   }
   
   {
     const char *err;
-    ret = gnutls_priority_set_direct(*session, mc->priority, &err);
-    if (ret != GNUTLS_E_SUCCESS) {
+    ret = gnutls_priority_set_direct(*session, mc.priority, &err);
+    if(ret != GNUTLS_E_SUCCESS){
       fprintf(stderr, "Syntax error at: %s\n", err);
       fprintf(stderr, "GnuTLS error: %s\n",
 	      safer_gnutls_strerror(ret));
-      gnutls_deinit (*session);
+      gnutls_deinit(*session);
       return -1;
     }
   }
   
   ret = gnutls_credentials_set(*session, GNUTLS_CRD_CERTIFICATE,
-			       mc->cred);
-  if (ret != GNUTLS_E_SUCCESS) {
+			       mc.cred);
+  if(ret != GNUTLS_E_SUCCESS){
     fprintf(stderr, "Error setting GnuTLS credentials: %s\n",
 	    safer_gnutls_strerror(ret));
-    gnutls_deinit (*session);
+    gnutls_deinit(*session);
     return -1;
   }
   
   /* ignore client certificate if any. */
-  gnutls_certificate_server_set_request (*session,
-					 GNUTLS_CERT_IGNORE);
+  gnutls_certificate_server_set_request(*session,
+					GNUTLS_CERT_IGNORE);
   
-  gnutls_dh_set_prime_bits (*session, mc->dh_bits);
+  gnutls_dh_set_prime_bits(*session, mc.dh_bits);
   
   return 0;
 }
@@ -499,9 +519,13 @@
 /* Called when a Mandos server is found */
 static int start_mandos_communication(const char *ip, uint16_t port,
 				      AvahiIfIndex if_index,
-				      mandos_context *mc){
+				      int af){
   int ret, tcp_sd;
-  union { struct sockaddr in; struct sockaddr_in6 in6; } to;
+  ssize_t sret;
+  union {
+    struct sockaddr_in in;
+    struct sockaddr_in6 in6;
+  } to;
   char *buffer = NULL;
   char *decrypted_buffer;
   size_t buffer_length = 0;
@@ -509,39 +533,46 @@
   ssize_t decrypted_buffer_size;
   size_t written;
   int retval = 0;
-  char interface[IF_NAMESIZE];
   gnutls_session_t session;
-  
-  ret = init_gnutls_session (mc, &session);
-  if (ret != 0){
+  int pf;			/* Protocol family */
+  
+  switch(af){
+  case AF_INET6:
+    pf = PF_INET6;
+    break;
+  case AF_INET:
+    pf = PF_INET;
+    break;
+  default:
+    fprintf(stderr, "Bad address family: %d\n", af);
+    return -1;
+  }
+  
+  ret = init_gnutls_session(&session);
+  if(ret != 0){
     return -1;
   }
   
   if(debug){
-    fprintf(stderr, "Setting up a tcp connection to %s, port %" PRIu16
+    fprintf(stderr, "Setting up a TCP connection to %s, port %" PRIu16
 	    "\n", ip, port);
   }
   
-  tcp_sd = socket(PF_INET6, SOCK_STREAM, 0);
-  if(tcp_sd < 0) {
+  tcp_sd = socket(pf, SOCK_STREAM, 0);
+  if(tcp_sd < 0){
     perror("socket");
     return -1;
   }
   
-  if(debug){
-    if(if_indextoname((unsigned int)if_index, interface) == NULL){
-      perror("if_indextoname");
-      return -1;
-    }
-    fprintf(stderr, "Binding to interface %s\n", interface);
-  }
-  
   memset(&to, 0, sizeof(to));
-  to.in6.sin6_family = AF_INET6;
-  /* It would be nice to have a way to detect if we were passed an
-     IPv4 address here.   Now we assume an IPv6 address. */
-  ret = inet_pton(AF_INET6, ip, &to.in6.sin6_addr);
-  if (ret < 0 ){
+  if(af == AF_INET6){
+    to.in6.sin6_family = (uint16_t)af;
+    ret = inet_pton(af, ip, &to.in6.sin6_addr);
+  } else {			/* IPv4 */
+    to.in.sin_family = (sa_family_t)af;
+    ret = inet_pton(af, ip, &to.in.sin_addr);
+  }
+  if(ret < 0 ){
     perror("inet_pton");
     return -1;
   }
@@ -549,16 +580,52 @@
     fprintf(stderr, "Bad address: %s\n", ip);
     return -1;
   }
-  to.in6.sin6_port = htons(port); /* Spurious warning */
-  
-  to.in6.sin6_scope_id = (uint32_t)if_index;
+  if(af == AF_INET6){
+    to.in6.sin6_port = htons(port); /* Spurious warnings from
+				       -Wconversion and
+				       -Wunreachable-code */
+    
+    if(IN6_IS_ADDR_LINKLOCAL /* Spurious warnings from */
+       (&to.in6.sin6_addr)){ /* -Wstrict-aliasing=2 or lower and
+			      -Wunreachable-code*/
+      if(if_index == AVAHI_IF_UNSPEC){
+	fprintf(stderr, "An IPv6 link-local address is incomplete"
+		" without a network interface\n");
+	return -1;
+      }
+      /* Set the network interface number as scope */
+      to.in6.sin6_scope_id = (uint32_t)if_index;
+    }
+  } else {
+    to.in.sin_port = htons(port); /* Spurious warnings from
+				     -Wconversion and
+				     -Wunreachable-code */
+  }
   
   if(debug){
-    fprintf(stderr, "Connection to: %s, port %" PRIu16 "\n", ip,
-	    port);
-    char addrstr[INET6_ADDRSTRLEN] = "";
-    if(inet_ntop(to.in6.sin6_family, &(to.in6.sin6_addr), addrstr,
-		 sizeof(addrstr)) == NULL){
+    if(af == AF_INET6 and if_index != AVAHI_IF_UNSPEC){
+      char interface[IF_NAMESIZE];
+      if(if_indextoname((unsigned int)if_index, interface) == NULL){
+	perror("if_indextoname");
+      } else {
+	fprintf(stderr, "Connection to: %s%%%s, port %" PRIu16 "\n",
+		ip, interface, port);
+      }
+    } else {
+      fprintf(stderr, "Connection to: %s, port %" PRIu16 "\n", ip,
+	      port);
+    }
+    char addrstr[(INET_ADDRSTRLEN > INET6_ADDRSTRLEN) ?
+		 INET_ADDRSTRLEN : INET6_ADDRSTRLEN] = "";
+    const char *pcret;
+    if(af == AF_INET6){
+      pcret = inet_ntop(af, &(to.in6.sin6_addr), addrstr,
+			sizeof(addrstr));
+    } else {
+      pcret = inet_ntop(af, &(to.in.sin_addr), addrstr,
+			sizeof(addrstr));
+    }
+    if(pcret == NULL){
       perror("inet_ntop");
     } else {
       if(strcmp(addrstr, ip) != 0){
@@ -567,19 +634,23 @@
     }
   }
   
-  ret = connect(tcp_sd, &to.in, sizeof(to));
-  if (ret < 0){
+  if(af == AF_INET6){
+    ret = connect(tcp_sd, &to.in6, sizeof(to));
+  } else {
+    ret = connect(tcp_sd, &to.in, sizeof(to)); /* IPv4 */
+  }
+  if(ret < 0){
     perror("connect");
     return -1;
   }
   
   const char *out = mandos_protocol_version;
   written = 0;
-  while (true){
+  while(true){
     size_t out_size = strlen(out);
-    ret = TEMP_FAILURE_RETRY(write(tcp_sd, out + written,
+    ret = (int)TEMP_FAILURE_RETRY(write(tcp_sd, out + written,
 				   out_size - written));
-    if (ret == -1){
+    if(ret == -1){
       perror("write");
       retval = -1;
       goto mandos_end;
@@ -588,7 +659,7 @@
     if(written < out_size){
       continue;
     } else {
-      if (out == mandos_protocol_version){
+      if(out == mandos_protocol_version){
 	written = 0;
 	out = "\r\n";
       } else {
@@ -601,16 +672,16 @@
     fprintf(stderr, "Establishing TLS session with %s\n", ip);
   }
   
-  gnutls_transport_set_ptr (session, (gnutls_transport_ptr_t) tcp_sd);
+  gnutls_transport_set_ptr(session, (gnutls_transport_ptr_t) tcp_sd);
   
   do{
-    ret = gnutls_handshake (session);
+    ret = gnutls_handshake(session);
   } while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
   
-  if (ret != GNUTLS_E_SUCCESS){
+  if(ret != GNUTLS_E_SUCCESS){
     if(debug){
       fprintf(stderr, "*** GnuTLS Handshake failed ***\n");
-      gnutls_perror (ret);
+      gnutls_perror(ret);
     }
     retval = -1;
     goto mandos_end;
@@ -619,36 +690,36 @@
   /* Read OpenPGP packet that contains the wanted password */
   
   if(debug){
-    fprintf(stderr, "Retrieving pgp encrypted password from %s\n",
+    fprintf(stderr, "Retrieving OpenPGP encrypted password from %s\n",
 	    ip);
   }
   
   while(true){
-    buffer_capacity = adjustbuffer(&buffer, buffer_length,
+    buffer_capacity = incbuffer(&buffer, buffer_length,
 				   buffer_capacity);
-    if (buffer_capacity == 0){
-      perror("adjustbuffer");
+    if(buffer_capacity == 0){
+      perror("incbuffer");
       retval = -1;
       goto mandos_end;
     }
     
-    ret = gnutls_record_recv(session, buffer+buffer_length,
-			     BUFFER_SIZE);
-    if (ret == 0){
+    sret = gnutls_record_recv(session, buffer+buffer_length,
+			      BUFFER_SIZE);
+    if(sret == 0){
       break;
     }
-    if (ret < 0){
-      switch(ret){
+    if(sret < 0){
+      switch(sret){
       case GNUTLS_E_INTERRUPTED:
       case GNUTLS_E_AGAIN:
 	break;
       case GNUTLS_E_REHANDSHAKE:
 	do{
-	  ret = gnutls_handshake (session);
+	  ret = gnutls_handshake(session);
 	} while(ret == GNUTLS_E_AGAIN or ret == GNUTLS_E_INTERRUPTED);
-	if (ret < 0){
+	if(ret < 0){
 	  fprintf(stderr, "*** GnuTLS Re-handshake failed ***\n");
-	  gnutls_perror (ret);
+	  gnutls_perror(ret);
 	  retval = -1;
 	  goto mandos_end;
 	}
@@ -657,11 +728,11 @@
 	fprintf(stderr, "Unknown error while reading data from"
 		" encrypted session with Mandos server\n");
 	retval = -1;
-	gnutls_bye (session, GNUTLS_SHUT_RDWR);
+	gnutls_bye(session, GNUTLS_SHUT_RDWR);
 	goto mandos_end;
       }
     } else {
-      buffer_length += (size_t) ret;
+      buffer_length += (size_t) sret;
     }
   }
   
@@ -669,18 +740,18 @@
     fprintf(stderr, "Closing TLS session\n");
   }
   
-  gnutls_bye (session, GNUTLS_SHUT_RDWR);
+  gnutls_bye(session, GNUTLS_SHUT_RDWR);
   
-  if (buffer_length > 0){
-    decrypted_buffer_size = pgp_packet_decrypt(mc, buffer,
+  if(buffer_length > 0){
+    decrypted_buffer_size = pgp_packet_decrypt(buffer,
 					       buffer_length,
 					       &decrypted_buffer);
-    if (decrypted_buffer_size >= 0){
+    if(decrypted_buffer_size >= 0){
       written = 0;
       while(written < (size_t) decrypted_buffer_size){
-	ret = (int)fwrite (decrypted_buffer + written, 1,
-			   (size_t)decrypted_buffer_size - written,
-			   stdout);
+	ret = (int)fwrite(decrypted_buffer + written, 1,
+			  (size_t)decrypted_buffer_size - written,
+			  stdout);
 	if(ret == 0 and ferror(stdout)){
 	  if(debug){
 	    fprintf(stderr, "Error writing encrypted data: %s\n",
@@ -703,17 +774,17 @@
   
  mandos_end:
   free(buffer);
-  ret = TEMP_FAILURE_RETRY(close(tcp_sd));
+  ret = (int)TEMP_FAILURE_RETRY(close(tcp_sd));
   if(ret == -1){
     perror("close");
   }
-  gnutls_deinit (session);
+  gnutls_deinit(session);
   return retval;
 }
 
 static void resolve_callback(AvahiSServiceResolver *r,
 			     AvahiIfIndex interface,
-			     AVAHI_GCC_UNUSED AvahiProtocol protocol,
+			     AvahiProtocol proto,
 			     AvahiResolverEvent event,
 			     const char *name,
 			     const char *type,
@@ -724,19 +795,18 @@
 			     AVAHI_GCC_UNUSED AvahiStringList *txt,
 			     AVAHI_GCC_UNUSED AvahiLookupResultFlags
 			     flags,
-			     void* userdata) {
-  mandos_context *mc = userdata;
+			     AVAHI_GCC_UNUSED void* userdata){
   assert(r);
   
   /* Called whenever a service has been resolved successfully or
      timed out */
   
-  switch (event) {
+  switch(event){
   default:
   case AVAHI_RESOLVER_FAILURE:
     fprintf(stderr, "(Avahi Resolver) Failed to resolve service '%s'"
 	    " of type '%s' in domain '%s': %s\n", name, type, domain,
-	    avahi_strerror(avahi_server_errno(mc->server)));
+	    avahi_strerror(avahi_server_errno(mc.server)));
     break;
     
   case AVAHI_RESOLVER_FOUND:
@@ -745,41 +815,41 @@
       avahi_address_snprint(ip, sizeof(ip), address);
       if(debug){
 	fprintf(stderr, "Mandos server \"%s\" found on %s (%s, %"
-		PRIu16 ") on port %d\n", name, host_name, ip,
-		interface, port);
+		PRIdMAX ") on port %" PRIu16 "\n", name, host_name,
+		ip, (intmax_t)interface, port);
       }
-      int ret = start_mandos_communication(ip, port, interface, mc);
-      if (ret == 0){
-	avahi_simple_poll_quit(mc->simple_poll);
+      int ret = start_mandos_communication(ip, port, interface,
+					   avahi_proto_to_af(proto));
+      if(ret == 0){
+	avahi_simple_poll_quit(mc.simple_poll);
       }
     }
   }
   avahi_s_service_resolver_free(r);
 }
 
-static void browse_callback( AvahiSServiceBrowser *b,
-			     AvahiIfIndex interface,
-			     AvahiProtocol protocol,
-			     AvahiBrowserEvent event,
-			     const char *name,
-			     const char *type,
-			     const char *domain,
-			     AVAHI_GCC_UNUSED AvahiLookupResultFlags
-			     flags,
-			     void* userdata) {
-  mandos_context *mc = userdata;
+static void browse_callback(AvahiSServiceBrowser *b,
+			    AvahiIfIndex interface,
+			    AvahiProtocol protocol,
+			    AvahiBrowserEvent event,
+			    const char *name,
+			    const char *type,
+			    const char *domain,
+			    AVAHI_GCC_UNUSED AvahiLookupResultFlags
+			    flags,
+			    AVAHI_GCC_UNUSED void* userdata){
   assert(b);
   
   /* Called whenever a new services becomes available on the LAN or
      is removed from the LAN */
   
-  switch (event) {
+  switch(event){
   default:
   case AVAHI_BROWSER_FAILURE:
     
     fprintf(stderr, "(Avahi browser) %s\n",
-	    avahi_strerror(avahi_server_errno(mc->server)));
-    avahi_simple_poll_quit(mc->simple_poll);
+	    avahi_strerror(avahi_server_errno(mc.server)));
+    avahi_simple_poll_quit(mc.simple_poll);
     return;
     
   case AVAHI_BROWSER_NEW:
@@ -788,12 +858,11 @@
        the callback function is called the Avahi server will free the
        resolver for us. */
     
-    if (!(avahi_s_service_resolver_new(mc->server, interface,
-				       protocol, name, type, domain,
-				       AVAHI_PROTO_INET6, 0,
-				       resolve_callback, mc)))
+    if(avahi_s_service_resolver_new(mc.server, interface, protocol,
+				    name, type, domain, protocol, 0,
+				    resolve_callback, NULL) == NULL)
       fprintf(stderr, "Avahi: Failed to resolve service '%s': %s\n",
-	      name, avahi_strerror(avahi_server_errno(mc->server)));
+	      name, avahi_strerror(avahi_server_errno(mc.server)));
     break;
     
   case AVAHI_BROWSER_REMOVE:
@@ -808,337 +877,471 @@
   }
 }
 
+sig_atomic_t quit_now = 0;
+
+/* stop main loop after sigterm has been called */
+static void handle_sigterm(__attribute__((unused)) int sig){
+  if(quit_now){
+    return;
+  }
+  quit_now = 1;
+  int old_errno = errno;
+  if(mc.simple_poll != NULL){
+    avahi_simple_poll_quit(mc.simple_poll);
+  }
+  errno = old_errno;
+}
+
 int main(int argc, char *argv[]){
-    AvahiSServiceBrowser *sb = NULL;
-    int error;
-    int ret;
-    int exitcode = EXIT_SUCCESS;
-    const char *interface = "eth0";
-    struct ifreq network;
-    int sd;
-    uid_t uid;
-    gid_t gid;
-    char *connect_to = NULL;
-    char tempdir[] = "/tmp/mandosXXXXXX";
-    AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
-    const char *seckey = PATHDIR "/" SECKEY;
-    const char *pubkey = PATHDIR "/" PUBKEY;
-    
-    mandos_context mc = { .simple_poll = NULL, .server = NULL,
-			  .dh_bits = 1024, .priority = "SECURE256"
-			  ":!CTYPE-X.509:+CTYPE-OPENPGP" };
-    bool gnutls_initalized = false;
-    bool gpgme_initalized = false;
-    
-    {
-      struct argp_option options[] = {
-	{ .name = "debug", .key = 128,
-	  .doc = "Debug mode", .group = 3 },
-	{ .name = "connect", .key = 'c',
-	  .arg = "ADDRESS:PORT",
-	  .doc = "Connect directly to a specific Mandos server",
-	  .group = 1 },
-	{ .name = "interface", .key = 'i',
-	  .arg = "NAME",
-	  .doc = "Interface that will be used to search for Mandos"
-	  " servers",
-	  .group = 1 },
-	{ .name = "seckey", .key = 's',
-	  .arg = "FILE",
-	  .doc = "OpenPGP secret key file base name",
-	  .group = 1 },
-	{ .name = "pubkey", .key = 'p',
-	  .arg = "FILE",
-	  .doc = "OpenPGP public key file base name",
-	  .group = 2 },
-	{ .name = "dh-bits", .key = 129,
-	  .arg = "BITS",
-	  .doc = "Bit length of the prime number used in the"
-	  " Diffie-Hellman key exchange",
-	  .group = 2 },
-	{ .name = "priority", .key = 130,
-	  .arg = "STRING",
-	  .doc = "GnuTLS priority string for the TLS handshake",
-	  .group = 1 },
-	{ .name = NULL }
-      };
-      
-      error_t parse_opt (int key, char *arg,
-			 struct argp_state *state) {
-	/* Get the INPUT argument from `argp_parse', which we know is
-	   a pointer to our plugin list pointer. */
-	switch (key) {
-	case 128:		/* --debug */
-	  debug = true;
-	  break;
-	case 'c':		/* --connect */
-	  connect_to = arg;
-	  break;
-	case 'i':		/* --interface */
-	  interface = arg;
-	  break;
-	case 's':		/* --seckey */
-	  seckey = arg;
-	  break;
-	case 'p':		/* --pubkey */
-	  pubkey = arg;
-	  break;
-	case 129:		/* --dh-bits */
-	  errno = 0;
-	  mc.dh_bits = (unsigned int) strtol(arg, NULL, 10);
-	  if (errno){
-	    perror("strtol");
-	    exit(EXIT_FAILURE);
+  AvahiSServiceBrowser *sb = NULL;
+  int error;
+  int ret;
+  intmax_t tmpmax;
+  char *tmp;
+  int exitcode = EXIT_SUCCESS;
+  const char *interface = "eth0";
+  struct ifreq network;
+  int sd;
+  uid_t uid;
+  gid_t gid;
+  char *connect_to = NULL;
+  char tempdir[] = "/tmp/mandosXXXXXX";
+  bool tempdir_created = false;
+  AvahiIfIndex if_index = AVAHI_IF_UNSPEC;
+  const char *seckey = PATHDIR "/" SECKEY;
+  const char *pubkey = PATHDIR "/" PUBKEY;
+  
+  bool gnutls_initialized = false;
+  bool gpgme_initialized = false;
+  float delay = 2.5f;
+  
+  struct sigaction old_sigterm_action;
+  struct sigaction sigterm_action = { .sa_handler = handle_sigterm };
+  
+  {
+    struct argp_option options[] = {
+      { .name = "debug", .key = 128,
+	.doc = "Debug mode", .group = 3 },
+      { .name = "connect", .key = 'c',
+	.arg = "ADDRESS:PORT",
+	.doc = "Connect directly to a specific Mandos server",
+	.group = 1 },
+      { .name = "interface", .key = 'i',
+	.arg = "NAME",
+	.doc = "Network interface that will be used to search for"
+	" Mandos servers",
+	.group = 1 },
+      { .name = "seckey", .key = 's',
+	.arg = "FILE",
+	.doc = "OpenPGP secret key file base name",
+	.group = 1 },
+      { .name = "pubkey", .key = 'p',
+	.arg = "FILE",
+	.doc = "OpenPGP public key file base name",
+	.group = 2 },
+      { .name = "dh-bits", .key = 129,
+	.arg = "BITS",
+	.doc = "Bit length of the prime number used in the"
+	" Diffie-Hellman key exchange",
+	.group = 2 },
+      { .name = "priority", .key = 130,
+	.arg = "STRING",
+	.doc = "GnuTLS priority string for the TLS handshake",
+	.group = 1 },
+      { .name = "delay", .key = 131,
+	.arg = "SECONDS",
+	.doc = "Maximum delay to wait for interface startup",
+	.group = 2 },
+      { .name = NULL }
+    };
+    
+    error_t parse_opt(int key, char *arg,
+		      struct argp_state *state){
+      switch(key){
+      case 128:			/* --debug */
+	debug = true;
+	break;
+      case 'c':			/* --connect */
+	connect_to = arg;
+	break;
+      case 'i':			/* --interface */
+	interface = arg;
+	break;
+      case 's':			/* --seckey */
+	seckey = arg;
+	break;
+      case 'p':			/* --pubkey */
+	pubkey = arg;
+	break;
+      case 129:			/* --dh-bits */
+	errno = 0;
+	tmpmax = strtoimax(arg, &tmp, 10);
+	if(errno != 0 or tmp == arg or *tmp != '\0'
+	   or tmpmax != (typeof(mc.dh_bits))tmpmax){
+	  fprintf(stderr, "Bad number of DH bits\n");
+	  exit(EXIT_FAILURE);
+	}
+	mc.dh_bits = (typeof(mc.dh_bits))tmpmax;
+	break;
+      case 130:			/* --priority */
+	mc.priority = arg;
+	break;
+      case 131:			/* --delay */
+	errno = 0;
+	delay = strtof(arg, &tmp);
+	if(errno != 0 or tmp == arg or *tmp != '\0'){
+	  fprintf(stderr, "Bad delay\n");
+	  exit(EXIT_FAILURE);
+	}
+	break;
+      case ARGP_KEY_ARG:
+	argp_usage(state);
+      case ARGP_KEY_END:
+	break;
+      default:
+	return ARGP_ERR_UNKNOWN;
+      }
+      return 0;
+    }
+    
+    struct argp argp = { .options = options, .parser = parse_opt,
+			 .args_doc = "",
+			 .doc = "Mandos client -- Get and decrypt"
+			 " passwords from a Mandos server" };
+    ret = argp_parse(&argp, argc, argv, 0, 0, NULL);
+    if(ret == ARGP_ERR_UNKNOWN){
+      fprintf(stderr, "Unknown error while parsing arguments\n");
+      exitcode = EXIT_FAILURE;
+      goto end;
+    }
+  }
+  
+  if(not debug){
+    avahi_set_log_function(empty_log);
+  }
+  
+  /* Initialize Avahi early so avahi_simple_poll_quit() can be called
+     from the signal handler */
+  /* Initialize the pseudo-RNG for Avahi */
+  srand((unsigned int) time(NULL));
+  mc.simple_poll = avahi_simple_poll_new();
+  if(mc.simple_poll == NULL){
+    fprintf(stderr, "Avahi: Failed to create simple poll object.\n");
+    exitcode = EXIT_FAILURE;
+    goto end;
+  }
+  
+  sigemptyset(&sigterm_action.sa_mask);
+  ret = sigaddset(&sigterm_action.sa_mask, SIGINT);
+  if(ret == -1){
+    perror("sigaddset");
+    exitcode = EXIT_FAILURE;
+    goto end;
+  }
+  ret = sigaddset(&sigterm_action.sa_mask, SIGHUP);
+  if(ret == -1){
+    perror("sigaddset");
+    exitcode = EXIT_FAILURE;
+    goto end;
+  }
+  ret = sigaddset(&sigterm_action.sa_mask, SIGTERM);
+  if(ret == -1){
+    perror("sigaddset");
+    exitcode = EXIT_FAILURE;
+    goto end;
+  }
+  ret = sigaction(SIGTERM, &sigterm_action, &old_sigterm_action);
+  if(ret == -1){
+    perror("sigaction");
+    exitcode = EXIT_FAILURE;
+    goto end;
+  }  
+  
+  /* If the interface is down, bring it up */
+  if(interface[0] != '\0'){
+#ifdef __linux__
+    /* Lower kernel loglevel to KERN_NOTICE to avoid KERN_INFO
+       messages to mess up the prompt */
+    ret = klogctl(8, NULL, 5);
+    bool restore_loglevel = true;
+    if(ret == -1){
+      restore_loglevel = false;
+      perror("klogctl");
+    }
+#endif	/* __linux__ */
+    
+    sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
+    if(sd < 0){
+      perror("socket");
+      exitcode = EXIT_FAILURE;
+#ifdef __linux__
+      if(restore_loglevel){
+	ret = klogctl(7, NULL, 0);
+	if(ret == -1){
+	  perror("klogctl");
+	}
+      }
+#endif	/* __linux__ */
+      goto end;
+    }
+    strcpy(network.ifr_name, interface);
+    ret = ioctl(sd, SIOCGIFFLAGS, &network);
+    if(ret == -1){
+      perror("ioctl SIOCGIFFLAGS");
+#ifdef __linux__
+      if(restore_loglevel){
+	ret = klogctl(7, NULL, 0);
+	if(ret == -1){
+	  perror("klogctl");
+	}
+      }
+#endif	/* __linux__ */
+      exitcode = EXIT_FAILURE;
+      goto end;
+    }
+    if((network.ifr_flags & IFF_UP) == 0){
+      network.ifr_flags |= IFF_UP;
+      ret = ioctl(sd, SIOCSIFFLAGS, &network);
+      if(ret == -1){
+	perror("ioctl SIOCSIFFLAGS");
+	exitcode = EXIT_FAILURE;
+#ifdef __linux__
+	if(restore_loglevel){
+	  ret = klogctl(7, NULL, 0);
+	  if(ret == -1){
+	    perror("klogctl");
 	  }
-	  break;
-	case 130:		/* --priority */
-	  mc.priority = arg;
-	  break;
-	case ARGP_KEY_ARG:
-	  argp_usage (state);
-	case ARGP_KEY_END:
-	  break;
-	default:
-	  return ARGP_ERR_UNKNOWN;
 	}
-	return 0;
-      }
-      
-      struct argp argp = { .options = options, .parser = parse_opt,
-			   .args_doc = "",
-			   .doc = "Mandos client -- Get and decrypt"
-			   " passwords from a Mandos server" };
-      ret = argp_parse (&argp, argc, argv, 0, 0, NULL);
-      if (ret == ARGP_ERR_UNKNOWN){
-	fprintf(stderr, "Unknown error while parsing arguments\n");
-	exitcode = EXIT_FAILURE;
+#endif	/* __linux__ */
 	goto end;
       }
     }
-    
-    /* If the interface is down, bring it up */
-    {
-      sd = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-      if(sd < 0) {
-	perror("socket");
-	exitcode = EXIT_FAILURE;
-	goto end;
-      }
-      strcpy(network.ifr_name, interface);
+    /* sleep checking until interface is running */
+    for(int i=0; i < delay * 4; i++){
       ret = ioctl(sd, SIOCGIFFLAGS, &network);
       if(ret == -1){
 	perror("ioctl SIOCGIFFLAGS");
-	exitcode = EXIT_FAILURE;
-	goto end;
-      }
-      if((network.ifr_flags & IFF_UP) == 0){
-	network.ifr_flags |= IFF_UP;
-	ret = ioctl(sd, SIOCSIFFLAGS, &network);
-	if(ret == -1){
-	  perror("ioctl SIOCSIFFLAGS");
-	  exitcode = EXIT_FAILURE;
-	  goto end;
-	}
-      }
-      ret = TEMP_FAILURE_RETRY(close(sd));
+      } else if(network.ifr_flags & IFF_RUNNING){
+	break;
+      }
+      struct timespec sleeptime = { .tv_nsec = 250000000 };
+      ret = nanosleep(&sleeptime, NULL);
+      if(ret == -1 and errno != EINTR){
+	perror("nanosleep");
+      }
+    }
+    ret = (int)TEMP_FAILURE_RETRY(close(sd));
+    if(ret == -1){
+      perror("close");
+    }
+#ifdef __linux__
+    if(restore_loglevel){
+      /* Restores kernel loglevel to default */
+      ret = klogctl(7, NULL, 0);
       if(ret == -1){
-	perror("close");
+	perror("klogctl");
       }
     }
-    
-    uid = getuid();
-    gid = getgid();
-    
-    ret = setuid(uid);
-    if (ret == -1){
-      perror("setuid");
-    }
-    
-    setgid(gid);
-    if (ret == -1){
-      perror("setgid");
-    }
-    
-    ret = init_gnutls_global(&mc, pubkey, seckey);
-    if (ret == -1){
-      fprintf(stderr, "init_gnutls_global failed\n");
-      exitcode = EXIT_FAILURE;
-      goto end;
-    } else {
-      gnutls_initalized = true;
-    }
-    
-    if(mkdtemp(tempdir) == NULL){
-      perror("mkdtemp");
-      tempdir[0] = '\0';
-      goto end;
-    }
-    
-    if(not init_gpgme(&mc, pubkey, seckey, tempdir)){
-      fprintf(stderr, "gpgme_initalized failed\n");
-      exitcode = EXIT_FAILURE;
-      goto end;
-    } else {
-      gpgme_initalized = true;
-    }
-    
+#endif	/* __linux__ */
+  }
+  
+  uid = getuid();
+  gid = getgid();
+  
+  errno = 0;
+  setgid(gid);
+  if(ret == -1){
+    perror("setgid");
+  }
+  
+  ret = setuid(uid);
+  if(ret == -1){
+    perror("setuid");
+  }
+  
+  ret = init_gnutls_global(pubkey, seckey);
+  if(ret == -1){
+    fprintf(stderr, "init_gnutls_global failed\n");
+    exitcode = EXIT_FAILURE;
+    goto end;
+  } else {
+    gnutls_initialized = true;
+  }
+  
+  if(mkdtemp(tempdir) == NULL){
+    perror("mkdtemp");
+    goto end;
+  }
+  tempdir_created = true;
+  
+  if(not init_gpgme(pubkey, seckey, tempdir)){
+    fprintf(stderr, "init_gpgme failed\n");
+    exitcode = EXIT_FAILURE;
+    goto end;
+  } else {
+    gpgme_initialized = true;
+  }
+  
+  if(interface[0] != '\0'){
     if_index = (AvahiIfIndex) if_nametoindex(interface);
     if(if_index == 0){
       fprintf(stderr, "No such interface: \"%s\"\n", interface);
-      exit(EXIT_FAILURE);
-    }
-    
-    if(connect_to != NULL){
-      /* Connect directly, do not use Zeroconf */
-      /* (Mainly meant for debugging) */
-      char *address = strrchr(connect_to, ':');
-      if(address == NULL){
-        fprintf(stderr, "No colon in address\n");
-	exitcode = EXIT_FAILURE;
-	goto end;
-      }
-      errno = 0;
-      uint16_t port = (uint16_t) strtol(address+1, NULL, 10);
-      if(errno){
-	perror("Bad port number");
-	exitcode = EXIT_FAILURE;
-	goto end;
-      }
-      *address = '\0';
-      address = connect_to;
-      ret = start_mandos_communication(address, port, if_index, &mc);
-      if(ret < 0){
-	exitcode = EXIT_FAILURE;
-      } else {
-	exitcode = EXIT_SUCCESS;
-      }
-      goto end;
-    }
-    
-    if (not debug){
-      avahi_set_log_function(empty_log);
-    }
-    
-    /* Initialize the pseudo-RNG for Avahi */
-    srand((unsigned int) time(NULL));
-    
-    /* Allocate main Avahi loop object */
-    mc.simple_poll = avahi_simple_poll_new();
-    if (mc.simple_poll == NULL) {
-        fprintf(stderr, "Avahi: Failed to create simple poll"
-		" object.\n");
-	exitcode = EXIT_FAILURE;
-        goto end;
-    }
-    
-    {
-      AvahiServerConfig config;
-      /* Do not publish any local Zeroconf records */
-      avahi_server_config_init(&config);
-      config.publish_hinfo = 0;
-      config.publish_addresses = 0;
-      config.publish_workstation = 0;
-      config.publish_domain = 0;
-      
-      /* Allocate a new server */
-      mc.server = avahi_server_new(avahi_simple_poll_get
-				   (mc.simple_poll), &config, NULL,
-				   NULL, &error);
-      
-      /* Free the Avahi configuration data */
-      avahi_server_config_free(&config);
-    }
-    
-    /* Check if creating the Avahi server object succeeded */
-    if (mc.server == NULL) {
-        fprintf(stderr, "Failed to create Avahi server: %s\n",
-		avahi_strerror(error));
-	exitcode = EXIT_FAILURE;
-        goto end;
-    }
-    
-    /* Create the Avahi service browser */
-    sb = avahi_s_service_browser_new(mc.server, if_index,
-				     AVAHI_PROTO_INET6,
-				     "_mandos._tcp", NULL, 0,
-				     browse_callback, &mc);
-    if (sb == NULL) {
-        fprintf(stderr, "Failed to create service browser: %s\n",
-		avahi_strerror(avahi_server_errno(mc.server)));
-	exitcode = EXIT_FAILURE;
-        goto end;
-    }
-    
-    /* Run the main loop */
-    
-    if (debug){
-      fprintf(stderr, "Starting Avahi loop search\n");
-    }
-    
-    avahi_simple_poll_loop(mc.simple_poll);
-    
+      exitcode = EXIT_FAILURE;
+      goto end;
+    }
+  }
+  
+  if(connect_to != NULL){
+    /* Connect directly, do not use Zeroconf */
+    /* (Mainly meant for debugging) */
+    char *address = strrchr(connect_to, ':');
+    if(address == NULL){
+      fprintf(stderr, "No colon in address\n");
+      exitcode = EXIT_FAILURE;
+      goto end;
+    }
+    uint16_t port;
+    errno = 0;
+    tmpmax = strtoimax(address+1, &tmp, 10);
+    if(errno != 0 or tmp == address+1 or *tmp != '\0'
+       or tmpmax != (uint16_t)tmpmax){
+      fprintf(stderr, "Bad port number\n");
+      exitcode = EXIT_FAILURE;
+      goto end;
+    }
+    port = (uint16_t)tmpmax;
+    *address = '\0';
+    address = connect_to;
+    /* Colon in address indicates IPv6 */
+    int af;
+    if(strchr(address, ':') != NULL){
+      af = AF_INET6;
+    } else {
+      af = AF_INET;
+    }
+    ret = start_mandos_communication(address, port, if_index, af);
+    if(ret < 0){
+      exitcode = EXIT_FAILURE;
+    } else {
+      exitcode = EXIT_SUCCESS;
+    }
+    goto end;
+  }
+    
+  {
+    AvahiServerConfig config;
+    /* Do not publish any local Zeroconf records */
+    avahi_server_config_init(&config);
+    config.publish_hinfo = 0;
+    config.publish_addresses = 0;
+    config.publish_workstation = 0;
+    config.publish_domain = 0;
+    
+    /* Allocate a new server */
+    mc.server = avahi_server_new(avahi_simple_poll_get
+				 (mc.simple_poll), &config, NULL,
+				 NULL, &error);
+    
+    /* Free the Avahi configuration data */
+    avahi_server_config_free(&config);
+  }
+  
+  /* Check if creating the Avahi server object succeeded */
+  if(mc.server == NULL){
+    fprintf(stderr, "Failed to create Avahi server: %s\n",
+	    avahi_strerror(error));
+    exitcode = EXIT_FAILURE;
+    goto end;
+  }
+  
+  /* Create the Avahi service browser */
+  sb = avahi_s_service_browser_new(mc.server, if_index,
+				   AVAHI_PROTO_UNSPEC, "_mandos._tcp",
+				   NULL, 0, browse_callback, NULL);
+  if(sb == NULL){
+    fprintf(stderr, "Failed to create service browser: %s\n",
+	    avahi_strerror(avahi_server_errno(mc.server)));
+    exitcode = EXIT_FAILURE;
+    goto end;
+  }
+  
+  /* Run the main loop */
+  
+  if(debug){
+    fprintf(stderr, "Starting Avahi loop search\n");
+  }
+  
+  avahi_simple_poll_loop(mc.simple_poll);
+  
  end:
-    
-    if (debug){
-      fprintf(stderr, "%s exiting\n", argv[0]);
-    }
-    
-    /* Cleanup things */
-    if (sb != NULL)
-        avahi_s_service_browser_free(sb);
-    
-    if (mc.server != NULL)
-        avahi_server_free(mc.server);
-    
-    if (mc.simple_poll != NULL)
-        avahi_simple_poll_free(mc.simple_poll);
-    
-    if (gnutls_initalized){
-      gnutls_certificate_free_credentials(mc.cred);
-      gnutls_global_deinit ();
-      gnutls_dh_params_deinit(mc.dh_params);
-    }
-    
-    if(gpgme_initalized){
-      gpgme_release(mc.ctx);
-    }
-    
-    /* Removes the temp directory used by GPGME */
-    if(tempdir[0] != '\0'){
-      DIR *d;
-      struct dirent *direntry;
-      d = opendir(tempdir);
-      if(d == NULL){
+  
+  if(debug){
+    fprintf(stderr, "%s exiting\n", argv[0]);
+  }
+  
+  /* Cleanup things */
+  if(sb != NULL)
+    avahi_s_service_browser_free(sb);
+  
+  if(mc.server != NULL)
+    avahi_server_free(mc.server);
+  
+  if(mc.simple_poll != NULL)
+    avahi_simple_poll_free(mc.simple_poll);
+  
+  if(gnutls_initialized){
+    gnutls_certificate_free_credentials(mc.cred);
+    gnutls_global_deinit();
+    gnutls_dh_params_deinit(mc.dh_params);
+  }
+  
+  if(gpgme_initialized){
+    gpgme_release(mc.ctx);
+  }
+  
+  /* Removes the temp directory used by GPGME */
+  if(tempdir_created){
+    DIR *d;
+    struct dirent *direntry;
+    d = opendir(tempdir);
+    if(d == NULL){
+      if(errno != ENOENT){
 	perror("opendir");
-      } else {
-	while(true){
-	  direntry = readdir(d);
-	  if(direntry == NULL){
-	    break;
-	  }
-	  if (direntry->d_type == DT_REG){
-	    char *fullname = NULL;
-	    ret = asprintf(&fullname, "%s/%s", tempdir,
-			   direntry->d_name);
-	    if(ret < 0){
-	      perror("asprintf");
-	      continue;
-	    }
-	    ret = unlink(fullname);
-	    if(ret == -1){
-	      fprintf(stderr, "unlink(\"%s\"): %s",
-		      fullname, strerror(errno));
-	    }
-	    free(fullname);
-	  }
-	}
-	closedir(d);
-      }
-      ret = rmdir(tempdir);
-      if(ret == -1){
-	perror("rmdir");
-      }
-    }
-	  
-    return exitcode;
+      }
+    } else {
+      while(true){
+	direntry = readdir(d);
+	if(direntry == NULL){
+	  break;
+	}
+	/* Skip "." and ".." */
+	if(direntry->d_name[0] == '.'
+	   and (direntry->d_name[1] == '\0'
+		or (direntry->d_name[1] == '.'
+		    and direntry->d_name[2] == '\0'))){
+	  continue;
+	}
+	char *fullname = NULL;
+	ret = asprintf(&fullname, "%s/%s", tempdir,
+		       direntry->d_name);
+	if(ret < 0){
+	  perror("asprintf");
+	  continue;
+	}
+	ret = remove(fullname);
+	if(ret == -1){
+	  fprintf(stderr, "remove(\"%s\"): %s\n", fullname,
+		  strerror(errno));
+	}
+	free(fullname);
+      }
+      closedir(d);
+    }
+    ret = rmdir(tempdir);
+    if(ret == -1 and errno != ENOENT){
+      perror("rmdir");
+    }
+  }
+  
+  return exitcode;
 }

=== modified file 'plugins.d/mandos-client.xml'
--- plugins.d/mandos-client.xml	2009-01-04 21:54:55 +0000
+++ plugins.d/mandos-client.xml	2009-02-09 02:01:13 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "mandos-client">
-<!ENTITY TIMESTAMP "2009-01-04">
+<!ENTITY TIMESTAMP "2009-02-09">
 <!ENTITY % common SYSTEM "../common.ent">
 %common;
 ]>
@@ -93,6 +93,10 @@
       </arg>
       <sbr/>
       <arg>
+	<option>--delay <replaceable>SECONDS</replaceable></option>
+      </arg>
+      <sbr/>
+      <arg>
 	<option>--debug</option>
       </arg>
     </cmdsynopsis>
@@ -122,11 +126,16 @@
       <command>&COMMANDNAME;</command> is a client program that
       communicates with <citerefentry><refentrytitle
       >mandos</refentrytitle><manvolnum>8</manvolnum></citerefentry>
-      to get a password.  It uses IPv6 link-local addresses to get
-      network connectivity, Zeroconf to find servers, and TLS with an
-      OpenPGP key to ensure authenticity and confidentiality.  It
-      keeps running, trying all servers on the network, until it
-      receives a satisfactory reply or a TERM signal is received.
+      to get a password.  In slightly more detail, this client program
+      brings up a network interface, uses the interface’s IPv6
+      link-local address to get network connectivity, uses Zeroconf to
+      find servers on the local network, and communicates with servers
+      using TLS with an OpenPGP key to ensure authenticity and
+      confidentiality.  This client program keeps running, trying all
+      servers on the network, until it receives a satisfactory reply
+      or a TERM signal is received.  If no servers are found, or after
+      all servers have been tried, it waits indefinitely for new
+      servers to appear.
     </para>
     <para>
       This program is not meant to be run directly; it is really meant
@@ -186,14 +195,14 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>--interface=
-	<replaceable>NAME</replaceable></option></term>
+	<term><option>--interface=<replaceable
+	>NAME</replaceable></option></term>
 	<term><option>-i
 	<replaceable>NAME</replaceable></option></term>
 	<listitem>
 	  <para>
 	    Network interface that will be brought up and scanned for
-	    Mandos servers to connect to.  The default it
+	    Mandos servers to connect to.  The default is
 	    <quote><literal>eth0</literal></quote>.
 	  </para>
 	  <para>
@@ -201,6 +210,21 @@
 	    specifies the interface to use to connect to the address
 	    given.
 	  </para>
+	  <para>
+	    Note that since this program will normally run in the
+	    initial RAM disk environment, the interface must be an
+	    interface which exists at that stage.  Thus, the interface
+	    can not be a pseudo-interface such as <quote>br0</quote>
+	    or <quote>tun0</quote>; such interfaces will not exist
+	    until much later in the boot process, and can not be used
+	    by this program.
+	  </para>
+	  <para>
+	    <replaceable>NAME</replaceable> can be the empty string;
+	    this will not use any specific interface, and will not
+	    bring up an interface on startup.  This is not
+	    recommended, and only meant for advanced users.
+	  </para>
 	</listitem>
       </varlistentry>
       
@@ -251,6 +275,22 @@
 	  </para>
 	</listitem>
       </varlistentry>
+
+      <varlistentry>
+	<term><option>--delay=<replaceable
+	>SECONDS</replaceable></option></term>
+	<listitem>
+	  <para>
+	    After bringing the network interface up, the program waits
+	    for the interface to arrive in a <quote>running</quote>
+	    state before proceeding.  During this time, the kernel log
+	    level will be lowered to reduce clutter on the system
+	    console, alleviating any other plugins which might be
+	    using the system console.  This option sets the upper
+	    limit of seconds to wait.  The default is 2.5 seconds.
+	  </para>
+	</listitem>
+      </varlistentry>
       
       <varlistentry>
 	<term><option>--debug</option></term>
@@ -412,15 +452,15 @@
     <informalexample>
       <para>
 	Run in debug mode, with a custom key, and do not use Zeroconf
-	to locate a server; connect directly to the IPv6 address
-	<quote><systemitem class="ipaddress"
-	>2001:db8:f983:bd0b:30de:ae4a:71f2:f672</systemitem></quote>,
-	port 4711, using interface eth2:
+	to locate a server; connect directly to the IPv6 link-local
+	address <quote><systemitem class="ipaddress"
+	>fe80::aede:48ff:fe71:f6f2</systemitem></quote>, port 4711,
+	using interface eth2:
       </para>
       <para>
 
 <!-- do not wrap this line -->
-<userinput>&COMMANDNAME; --debug --pubkey keydir/pubkey.txt --seckey keydir/seckey.txt --connect 2001:db8:f983:bd0b:30de:ae4a:71f2:f672:4711 --interface eth2</userinput>
+<userinput>&COMMANDNAME; --debug --pubkey keydir/pubkey.txt --seckey keydir/seckey.txt --connect fe80::aede:48ff:fe71:f6f2:4711 --interface eth2</userinput>
 
       </para>
     </informalexample>

=== modified file 'plugins.d/password-prompt.c'
--- plugins.d/password-prompt.c	2009-01-08 03:54:06 +0000
+++ plugins.d/password-prompt.c	2009-02-05 02:33:05 +0000
@@ -1,6 +1,6 @@
 /*  -*- coding: utf-8 -*- */
 /*
- * Passprompt - Read a password from the terminal and print it
+ * Password-prompt - Read a password from the terminal and print it
  * 
  * Copyright © 2008,2009 Teddy Hogeborn
  * Copyright © 2008,2009 Björn Påhlsson
@@ -51,13 +51,13 @@
 				   ARGP_KEY_ARG, ARGP_KEY_END,
 				   ARGP_ERR_UNKNOWN */
 
-volatile bool quit_now = false;
+volatile sig_atomic_t quit_now = 0;
 bool debug = false;
 const char *argp_program_version = "password-prompt " VERSION;
 const char *argp_program_bug_address = "<mandos@fukt.bsnet.se>";
 
 static void termination_handler(__attribute__((unused))int signum){
-  quit_now = true;
+  quit_now = 1;
 }
 
 int main(int argc, char **argv){
@@ -80,10 +80,8 @@
       { .name = NULL }
     };
     
-    error_t parse_opt (int key, char *arg, struct argp_state *state) {
-      /* Get the INPUT argument from `argp_parse', which we know is a
-	 pointer to our plugin list pointer. */
-      switch (key) {
+    error_t parse_opt (int key, char *arg, struct argp_state *state){
+      switch (key){
       case 'p':
 	prefix = arg;
 	break;
@@ -91,7 +89,7 @@
 	debug = true;
 	break;
       case ARGP_KEY_ARG:
-	argp_usage (state);
+	argp_usage(state);
 	break;
       case ARGP_KEY_END:
 	break;
@@ -105,21 +103,21 @@
 			 .args_doc = "",
 			 .doc = "Mandos password-prompt -- Read and"
 			 " output a password" };
-    ret = argp_parse (&argp, argc, argv, 0, 0, NULL);
-    if (ret == ARGP_ERR_UNKNOWN){
+    ret = argp_parse(&argp, argc, argv, 0, 0, NULL);
+    if(ret == ARGP_ERR_UNKNOWN){
       fprintf(stderr, "Unknown error while parsing arguments\n");
       return EXIT_FAILURE;
     }
   }
   
-  if (debug){
+  if(debug){
     fprintf(stderr, "Starting %s\n", argv[0]);
   }
-  if (debug){
+  if(debug){
     fprintf(stderr, "Storing current terminal attributes\n");
   }
   
-  if (tcgetattr(STDIN_FILENO, &t_old) != 0){
+  if(tcgetattr(STDIN_FILENO, &t_old) != 0){
     perror("tcgetattr");
     return EXIT_FAILURE;
   }
@@ -133,7 +131,7 @@
     perror("sigaction");
     return EXIT_FAILURE;
   }
-  if (old_action.sa_handler != SIG_IGN){
+  if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGINT, &new_action, NULL);
     if(ret == -1){
       perror("sigaction");
@@ -145,7 +143,7 @@
     perror("sigaction");
     return EXIT_FAILURE;
   }
-  if (old_action.sa_handler != SIG_IGN){
+  if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGHUP, &new_action, NULL);
     if(ret == -1){
       perror("sigaction");
@@ -157,7 +155,7 @@
     perror("sigaction");
     return EXIT_FAILURE;
   }
-  if (old_action.sa_handler != SIG_IGN){
+  if(old_action.sa_handler != SIG_IGN){
     ret = sigaction(SIGTERM, &new_action, NULL);
     if(ret == -1){
       perror("sigaction");
@@ -166,22 +164,22 @@
   }
   
   
-  if (debug){
+  if(debug){
     fprintf(stderr, "Removing echo flag from terminal attributes\n");
   }
   
   t_new = t_old;
   t_new.c_lflag &= ~ECHO;
-  if (tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_new) != 0){
+  if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_new) != 0){
     perror("tcsetattr-echo");
     return EXIT_FAILURE;
   }
 
-  if (debug){
+  if(debug){
     fprintf(stderr, "Waiting for input from stdin \n");
   }
   while(true){
-    if (quit_now){
+    if(quit_now){
       if(debug){
 	fprintf(stderr, "Interrupted by signal, exiting.\n");
       }
@@ -196,7 +194,7 @@
       const char *cryptsource = getenv("cryptsource");
       const char *crypttarget = getenv("crypttarget");
       const char *const prompt
-	= "Enter passphrase to unlock the disk";
+	= "Enter passphrase to unlock the disk";      
       if(cryptsource == NULL){
 	if(crypttarget == NULL){
 	  fprintf(stderr, "%s: ", prompt);
@@ -213,7 +211,7 @@
       }
     }
     ret = getline(&buffer, &n, stdin);
-    if (ret > 0){
+    if(ret > 0){
       status = EXIT_SUCCESS;
       /* Make n = data size instead of allocated buffer size */
       n = (size_t)ret;
@@ -234,8 +232,8 @@
       }
       break;
     }
-    if (ret < 0){
-      if (errno != EINTR and not feof(stdin)){
+    if(ret < 0){
+      if(errno != EINTR and not feof(stdin)){
 	perror("getline");
 	status = EXIT_FAILURE;
 	break;
@@ -244,8 +242,8 @@
     /* if(ret == 0), then the only sensible thing to do is to retry to
        read from stdin */
     fputc('\n', stderr);
-    if(debug and not quit_now){
-      /* If quit_now is true, we were interrupted by a signal, and
+    if(debug and quit_now == 0){
+      /* If quit_now is nonzero, we were interrupted by a signal, and
 	 will print that later, so no need to show this too. */
       fprintf(stderr, "getline() returned 0, retrying.\n");
     }
@@ -253,14 +251,14 @@
   
   free(buffer);
   
-  if (debug){
+  if(debug){
     fprintf(stderr, "Restoring terminal attributes\n");
   }
-  if (tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_old) != 0){
+  if(tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_old) != 0){
     perror("tcsetattr+echo");
   }
   
-  if (debug){
+  if(debug){
     fprintf(stderr, "%s is exiting with status %d\n", argv[0],
 	    status);
   }

=== modified file 'plugins.d/splashy.c'
--- plugins.d/splashy.c	2009-01-04 21:54:55 +0000
+++ plugins.d/splashy.c	2009-02-12 18:56:52 +0000
@@ -1,6 +1,6 @@
 /*  -*- coding: utf-8 -*- */
 /*
- * Passprompt - Read a password from splashy and output it
+ * Splashy - Read a password from splashy and output it
  * 
  * Copyright © 2008,2009 Teddy Hogeborn
  * Copyright © 2008,2009 Björn Påhlsson
@@ -31,11 +31,12 @@
 #include <stddef.h>		/* NULL */
 #include <stdlib.h>		/* getenv() */
 #include <stdio.h>		/* asprintf(), perror() */
-#include <stdlib.h>		/* EXIT_FAILURE, free(), strtoul(),
+#include <stdlib.h>		/* EXIT_FAILURE, free(),
 				   EXIT_SUCCESS */
 #include <sys/types.h>		/* pid_t, DIR, struct dirent,
 				   ssize_t */
 #include <dirent.h>		/* opendir(), readdir(), closedir() */
+#include <inttypes.h>		/* intmax_t, strtoimax() */
 #include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
 #include <iso646.h>		/* not, or, and */
 #include <unistd.h>		/* readlink(), fork(), execl(),
@@ -97,10 +98,18 @@
     for(struct dirent *proc_ent = readdir(proc_dir);
 	proc_ent != NULL;
 	proc_ent = readdir(proc_dir)){
-      pid_t pid = (pid_t) strtoul(proc_ent->d_name, NULL, 10);
-      if(pid == 0){
-	/* Not a process */
-	continue;
+      pid_t pid;
+      {
+	intmax_t tmpmax;
+	char *tmp;
+	errno = 0;
+	tmpmax = strtoimax(proc_ent->d_name, &tmp, 10);
+	if(errno != 0 or tmp == proc_ent->d_name or *tmp != '\0'
+	   or tmpmax != (pid_t)tmpmax){
+	  /* Not a process */
+	  continue;
+	}
+	pid = (pid_t)tmpmax;
       }
       /* Find the executable name by doing readlink() on the
 	 /proc/<pid>/exe link */
@@ -120,6 +129,10 @@
 	struct stat exe_stat;
 	ret = lstat(exe_link, &exe_stat);
 	if(ret == -1){
+	  if(errno == ENOENT){
+	    free(exe_link);
+	    continue;
+	  }
 	  perror("lstat");
 	  free(exe_link);
 	  free(prompt);
@@ -263,7 +276,7 @@
     /* Child; will become new splashy process */
     
     /* Make the effective user ID (root) the only user ID instead of
-       the real user ID (mandos) */
+       the real user ID (_mandos) */
     ret = setuid(geteuid());
     if(ret == -1){
       perror("setuid");

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2009-01-04 21:54:55 +0000
+++ plugins.d/usplash.c	2009-02-12 18:56:52 +0000
@@ -1,6 +1,6 @@
 /*  -*- coding: utf-8 -*- */
 /*
- * Passprompt - Read a password from usplash and output it
+ * Usplash - Read a password from usplash and output it
  * 
  * Copyright © 2008,2009 Teddy Hogeborn
  * Copyright © 2008,2009 Björn Påhlsson
@@ -42,11 +42,11 @@
 				   fork(), setuid(), geteuid(),
 				   setsid(), chdir(), dup2(),
 				   STDERR_FILENO, execv() */
-#include <stdlib.h>		/* free(), EXIT_FAILURE, strtoul(),
-				   realloc(), EXIT_SUCCESS, malloc(),
-				   _exit() */
+#include <stdlib.h>		/* free(), EXIT_FAILURE, realloc(),
+				   EXIT_SUCCESS, malloc(), _exit() */
 #include <stdlib.h>		/* getenv() */
 #include <dirent.h>		/* opendir(), readdir(), closedir() */
+#include <inttypes.h>		/* intmax_t, strtoimax() */
 #include <sys/stat.h>		/* struct stat, lstat(), S_ISLNK */
 
 sig_atomic_t interrupted_by_signal = 0;
@@ -92,10 +92,11 @@
   }
   
   size_t written = 0;
+  ssize_t sret = 0;
   while(not interrupted_by_signal and written < cmd_line_len){
-    ret = write(fifo_fd, cmd_line + written,
-		cmd_line_len - written);
-    if(ret == -1){
+    sret = write(fifo_fd, cmd_line + written,
+		 cmd_line_len - written);
+    if(sret == -1){
       if(errno != EINTR or interrupted_by_signal){
 	int e = errno;
 	close(fifo_fd);
@@ -106,7 +107,7 @@
 	continue;
       }
     }
-    written += (size_t)ret;
+    written += (size_t)sret;
   }
   free(cmd_line_alloc);
   do{
@@ -169,10 +170,18 @@
     for(struct dirent *proc_ent = readdir(proc_dir);
 	proc_ent != NULL;
 	proc_ent = readdir(proc_dir)){
-      pid_t pid = (pid_t) strtoul(proc_ent->d_name, NULL, 10);
-      if(pid == 0){
-	/* Not a process */
-	continue;
+      pid_t pid;
+      {
+	intmax_t tmpmax;
+	char *tmp;
+	errno = 0;
+	tmpmax = strtoimax(proc_ent->d_name, &tmp, 10);
+	if(errno != 0 or tmp == proc_ent->d_name or *tmp != '\0'
+	   or tmpmax != (pid_t)tmpmax){
+	  /* Not a process */
+	  continue;
+	}
+	pid = (pid_t)tmpmax;
       }
       /* Find the executable name by doing readlink() on the
 	 /proc/<pid>/exe link */
@@ -192,6 +201,10 @@
 	struct stat exe_stat;
 	ret = lstat(exe_link, &exe_stat);
 	if(ret == -1){
+	  if(errno == ENOENT){
+	    free(exe_link);
+	    continue;
+	  }
 	  perror("lstat");
 	  free(exe_link);
 	  free(prompt);
@@ -207,9 +220,6 @@
 	
 	sret = readlink(exe_link, exe_target, sizeof(exe_target));
 	free(exe_link);
-	if(sret == -1){
-	  continue;
-	}
       }
       if((sret == ((ssize_t)sizeof(exe_target)-1))
 	 and (memcmp(usplash_name, exe_target,
@@ -484,7 +494,7 @@
     /* Child; will become new usplash process */
     
     /* Make the effective user ID (root) the only user ID instead of
-       the real user ID (mandos) */
+       the real user ID (_mandos) */
     ret = setuid(geteuid());
     if(ret == -1){
       perror("setuid");

